/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

#ifdef ENABLE_CHECKING
  memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
  memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
#endif

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 2027:  /* *dmb */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 2026:  /* aarch64_store_exclusivedi */
    case 2025:  /* aarch64_store_exclusivesi */
    case 2024:  /* aarch64_store_exclusivehi */
    case 2023:  /* aarch64_store_exclusiveqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      break;

    case 2020:  /* aarch64_load_exclusivehi */
    case 2019:  /* aarch64_load_exclusiveqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      break;

    case 2010:  /* atomic_nand_fetchdi */
    case 2009:  /* atomic_nand_fetchsi */
    case 2008:  /* atomic_nand_fetchhi */
    case 2007:  /* atomic_nand_fetchqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[2] = 1;
      break;

    case 2006:  /* atomic_and_fetchdi */
    case 2005:  /* atomic_xor_fetchdi */
    case 2004:  /* atomic_or_fetchdi */
    case 2003:  /* atomic_sub_fetchdi */
    case 2002:  /* atomic_add_fetchdi */
    case 2001:  /* atomic_and_fetchsi */
    case 2000:  /* atomic_xor_fetchsi */
    case 1999:  /* atomic_or_fetchsi */
    case 1998:  /* atomic_sub_fetchsi */
    case 1997:  /* atomic_add_fetchsi */
    case 1996:  /* atomic_and_fetchhi */
    case 1995:  /* atomic_xor_fetchhi */
    case 1994:  /* atomic_or_fetchhi */
    case 1993:  /* atomic_sub_fetchhi */
    case 1992:  /* atomic_add_fetchhi */
    case 1991:  /* atomic_and_fetchqi */
    case 1990:  /* atomic_xor_fetchqi */
    case 1989:  /* atomic_or_fetchqi */
    case 1988:  /* atomic_sub_fetchqi */
    case 1987:  /* atomic_add_fetchqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[2] = 1;
      break;

    case 1986:  /* atomic_fetch_nanddi */
    case 1985:  /* atomic_fetch_nandsi */
    case 1984:  /* atomic_fetch_nandhi */
    case 1983:  /* atomic_fetch_nandqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 4), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1982:  /* atomic_fetch_anddi */
    case 1981:  /* atomic_fetch_xordi */
    case 1980:  /* atomic_fetch_ordi */
    case 1979:  /* atomic_fetch_subdi */
    case 1978:  /* atomic_fetch_adddi */
    case 1977:  /* atomic_fetch_andsi */
    case 1976:  /* atomic_fetch_xorsi */
    case 1975:  /* atomic_fetch_orsi */
    case 1974:  /* atomic_fetch_subsi */
    case 1973:  /* atomic_fetch_addsi */
    case 1972:  /* atomic_fetch_andhi */
    case 1971:  /* atomic_fetch_xorhi */
    case 1970:  /* atomic_fetch_orhi */
    case 1969:  /* atomic_fetch_subhi */
    case 1968:  /* atomic_fetch_addhi */
    case 1967:  /* atomic_fetch_andqi */
    case 1966:  /* atomic_fetch_xorqi */
    case 1965:  /* atomic_fetch_orqi */
    case 1964:  /* atomic_fetch_subqi */
    case 1963:  /* atomic_fetch_addqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 4), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1962:  /* atomic_nanddi */
    case 1961:  /* atomic_nandsi */
    case 1960:  /* atomic_nandhi */
    case 1959:  /* atomic_nandqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 1958:  /* atomic_anddi */
    case 1957:  /* atomic_xordi */
    case 1956:  /* atomic_ordi */
    case 1955:  /* atomic_subdi */
    case 1954:  /* atomic_adddi */
    case 1953:  /* atomic_andsi */
    case 1952:  /* atomic_xorsi */
    case 1951:  /* atomic_orsi */
    case 1950:  /* atomic_subsi */
    case 1949:  /* atomic_addsi */
    case 1948:  /* atomic_andhi */
    case 1947:  /* atomic_xorhi */
    case 1946:  /* atomic_orhi */
    case 1945:  /* atomic_subhi */
    case 1944:  /* atomic_addhi */
    case 1943:  /* atomic_andqi */
    case 1942:  /* atomic_xorqi */
    case 1941:  /* atomic_orqi */
    case 1940:  /* atomic_subqi */
    case 1939:  /* atomic_addqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 1938:  /* atomic_exchangedi */
    case 1937:  /* atomic_exchangesi */
    case 1936:  /* atomic_exchangehi */
    case 1935:  /* atomic_exchangeqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1934:  /* atomic_compare_and_swapdi_1 */
    case 1933:  /* atomic_compare_and_swapsi_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 4));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 2), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1932:  /* atomic_compare_and_swaphi_1 */
    case 1931:  /* atomic_compare_and_swapqi_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 4));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 2), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1831:  /* aarch64_ld4df_dreg */
    case 1830:  /* aarch64_ld4di_dreg */
    case 1829:  /* aarch64_ld4v2sf_dreg */
    case 1828:  /* aarch64_ld4v2si_dreg */
    case 1827:  /* aarch64_ld4v4hi_dreg */
    case 1826:  /* aarch64_ld4v8qi_dreg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0), 0, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0), 0, 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0), 0, 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 1), 0), 0, 0);
      recog_data.dup_num[2] = 1;
      break;

    case 1825:  /* aarch64_ld3df_dreg */
    case 1824:  /* aarch64_ld3di_dreg */
    case 1823:  /* aarch64_ld3v2sf_dreg */
    case 1822:  /* aarch64_ld3v2si_dreg */
    case 1821:  /* aarch64_ld3v4hi_dreg */
    case 1820:  /* aarch64_ld3v8qi_dreg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0), 0, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0), 0, 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1819:  /* aarch64_ld2df_dreg */
    case 1818:  /* aarch64_ld2di_dreg */
    case 1817:  /* aarch64_ld2v2sf_dreg */
    case 1816:  /* aarch64_ld2v2si_dreg */
    case 1815:  /* aarch64_ld2v4hi_dreg */
    case 1814:  /* aarch64_ld2v8qi_dreg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0, 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1399:  /* aarch64_sqdmull2_nv4si_internal */
    case 1398:  /* aarch64_sqdmull2_nv8hi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 1));
      break;

    case 1397:  /* aarch64_sqdmull2_lanev4si_internal */
    case 1396:  /* aarch64_sqdmull2_lanev8hi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0), 1), 0, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 1));
      break;

    case 1395:  /* aarch64_sqdmull2v4si_internal */
    case 1394:  /* aarch64_sqdmull2v8hi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 1);
      recog_data.dup_num[0] = 3;
      break;

    case 1393:  /* aarch64_sqdmull_nv2si */
    case 1392:  /* aarch64_sqdmull_nv4hi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0));
      break;

    case 1391:  /* aarch64_sqdmull_lanesi_internal */
    case 1390:  /* aarch64_sqdmull_lanehi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 1), 0, 0));
      break;

    case 1389:  /* aarch64_sqdmull_lanev2si_internal */
    case 1388:  /* aarch64_sqdmull_lanev4hi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0), 1), 0, 0));
      break;

    case 1761:  /* *aarch64_facgtdf */
    case 1760:  /* *aarch64_facgedf */
    case 1759:  /* *aarch64_facledf */
    case 1758:  /* *aarch64_facltdf */
    case 1757:  /* *aarch64_facgtsf */
    case 1756:  /* *aarch64_facgesf */
    case 1755:  /* *aarch64_faclesf */
    case 1754:  /* *aarch64_facltsf */
    case 1753:  /* *aarch64_facgtv2df */
    case 1752:  /* *aarch64_facgev2df */
    case 1751:  /* *aarch64_faclev2df */
    case 1750:  /* *aarch64_facltv2df */
    case 1749:  /* *aarch64_facgtv4sf */
    case 1748:  /* *aarch64_facgev4sf */
    case 1747:  /* *aarch64_faclev4sf */
    case 1746:  /* *aarch64_facltv4sf */
    case 1745:  /* *aarch64_facgtv2sf */
    case 1744:  /* *aarch64_facgev2sf */
    case 1743:  /* *aarch64_faclev2sf */
    case 1742:  /* *aarch64_facltv2sf */
    case 1387:  /* aarch64_sqdmullsi */
    case 1386:  /* aarch64_sqdmullhi */
    case 1385:  /* aarch64_sqdmullv2si */
    case 1384:  /* aarch64_sqdmullv4hi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      break;

    case 1383:  /* aarch64_sqdmlsl2_nv4si_internal */
    case 1382:  /* aarch64_sqdmlal2_nv4si_internal */
    case 1381:  /* aarch64_sqdmlsl2_nv8hi_internal */
    case 1380:  /* aarch64_sqdmlal2_nv8hi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0), 1));
      break;

    case 1379:  /* aarch64_sqdmlsl2_lanev4si_internal */
    case 1378:  /* aarch64_sqdmlal2_lanev4si_internal */
    case 1377:  /* aarch64_sqdmlsl2_lanev8hi_internal */
    case 1376:  /* aarch64_sqdmlal2_lanev8hi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 0), 0));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 0), 1), 0, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0), 1));
      break;

    case 1375:  /* aarch64_sqdmlsl2v4si_internal */
    case 1374:  /* aarch64_sqdmlal2v4si_internal */
    case 1373:  /* aarch64_sqdmlsl2v8hi_internal */
    case 1372:  /* aarch64_sqdmlal2v8hi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 1);
      recog_data.dup_num[0] = 4;
      break;

    case 1371:  /* aarch64_sqdmlsl_nv2si */
    case 1370:  /* aarch64_sqdmlal_nv2si */
    case 1369:  /* aarch64_sqdmlsl_nv4hi */
    case 1368:  /* aarch64_sqdmlal_nv4hi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 0));
      break;

    case 1367:  /* aarch64_sqdmlsl_lanesi_internal */
    case 1366:  /* aarch64_sqdmlal_lanesi_internal */
    case 1365:  /* aarch64_sqdmlsl_lanehi_internal */
    case 1364:  /* aarch64_sqdmlal_lanehi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 1), 0, 0));
      break;

    case 1363:  /* aarch64_sqdmlsl_lanev2si_internal */
    case 1362:  /* aarch64_sqdmlal_lanev2si_internal */
    case 1361:  /* aarch64_sqdmlsl_lanev4hi_internal */
    case 1360:  /* aarch64_sqdmlal_lanev4hi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 0), 0));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 0), 1), 0, 0));
      break;

    case 1359:  /* aarch64_sqdmlslsi */
    case 1358:  /* aarch64_sqdmlalsi */
    case 1357:  /* aarch64_sqdmlslhi */
    case 1356:  /* aarch64_sqdmlalhi */
    case 1355:  /* aarch64_sqdmlslv2si */
    case 1354:  /* aarch64_sqdmlalv2si */
    case 1353:  /* aarch64_sqdmlslv4hi */
    case 1352:  /* aarch64_sqdmlalv4hi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0));
      break;

    case 1351:  /* aarch64_sqrdmulh_lanesi */
    case 1350:  /* aarch64_sqdmulh_lanesi */
    case 1349:  /* aarch64_sqrdmulh_lanehi */
    case 1348:  /* aarch64_sqdmulh_lanehi */
    case 1347:  /* aarch64_sqrdmulh_laneqv4si */
    case 1346:  /* aarch64_sqdmulh_laneqv4si */
    case 1345:  /* aarch64_sqrdmulh_laneqv2si */
    case 1344:  /* aarch64_sqdmulh_laneqv2si */
    case 1343:  /* aarch64_sqrdmulh_laneqv8hi */
    case 1342:  /* aarch64_sqdmulh_laneqv8hi */
    case 1341:  /* aarch64_sqrdmulh_laneqv4hi */
    case 1340:  /* aarch64_sqdmulh_laneqv4hi */
    case 1339:  /* aarch64_sqrdmulh_lanev4si */
    case 1338:  /* aarch64_sqdmulh_lanev4si */
    case 1337:  /* aarch64_sqrdmulh_lanev2si */
    case 1336:  /* aarch64_sqdmulh_lanev2si */
    case 1335:  /* aarch64_sqrdmulh_lanev8hi */
    case 1334:  /* aarch64_sqdmulh_lanev8hi */
    case 1333:  /* aarch64_sqrdmulh_lanev4hi */
    case 1332:  /* aarch64_sqdmulh_lanev4hi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 0));
      break;

    case 1567:  /* aarch64_usri_ndi */
    case 1566:  /* aarch64_ssri_ndi */
    case 1565:  /* aarch64_usli_ndi */
    case 1564:  /* aarch64_ssli_ndi */
    case 1563:  /* aarch64_usri_nv2di */
    case 1562:  /* aarch64_ssri_nv2di */
    case 1561:  /* aarch64_usli_nv2di */
    case 1560:  /* aarch64_ssli_nv2di */
    case 1559:  /* aarch64_usri_nv4si */
    case 1558:  /* aarch64_ssri_nv4si */
    case 1557:  /* aarch64_usli_nv4si */
    case 1556:  /* aarch64_ssli_nv4si */
    case 1555:  /* aarch64_usri_nv2si */
    case 1554:  /* aarch64_ssri_nv2si */
    case 1553:  /* aarch64_usli_nv2si */
    case 1552:  /* aarch64_ssli_nv2si */
    case 1551:  /* aarch64_usri_nv8hi */
    case 1550:  /* aarch64_ssri_nv8hi */
    case 1549:  /* aarch64_usli_nv8hi */
    case 1548:  /* aarch64_ssli_nv8hi */
    case 1547:  /* aarch64_usri_nv4hi */
    case 1546:  /* aarch64_ssri_nv4hi */
    case 1545:  /* aarch64_usli_nv4hi */
    case 1544:  /* aarch64_ssli_nv4hi */
    case 1543:  /* aarch64_usri_nv16qi */
    case 1542:  /* aarch64_ssri_nv16qi */
    case 1541:  /* aarch64_usli_nv16qi */
    case 1540:  /* aarch64_ssli_nv16qi */
    case 1539:  /* aarch64_usri_nv8qi */
    case 1538:  /* aarch64_ssri_nv8qi */
    case 1537:  /* aarch64_usli_nv8qi */
    case 1536:  /* aarch64_ssli_nv8qi */
    case 1535:  /* aarch64_ursra_ndi */
    case 1534:  /* aarch64_srsra_ndi */
    case 1533:  /* aarch64_usra_ndi */
    case 1532:  /* aarch64_ssra_ndi */
    case 1531:  /* aarch64_ursra_nv2di */
    case 1530:  /* aarch64_srsra_nv2di */
    case 1529:  /* aarch64_usra_nv2di */
    case 1528:  /* aarch64_ssra_nv2di */
    case 1527:  /* aarch64_ursra_nv4si */
    case 1526:  /* aarch64_srsra_nv4si */
    case 1525:  /* aarch64_usra_nv4si */
    case 1524:  /* aarch64_ssra_nv4si */
    case 1523:  /* aarch64_ursra_nv2si */
    case 1522:  /* aarch64_srsra_nv2si */
    case 1521:  /* aarch64_usra_nv2si */
    case 1520:  /* aarch64_ssra_nv2si */
    case 1519:  /* aarch64_ursra_nv8hi */
    case 1518:  /* aarch64_srsra_nv8hi */
    case 1517:  /* aarch64_usra_nv8hi */
    case 1516:  /* aarch64_ssra_nv8hi */
    case 1515:  /* aarch64_ursra_nv4hi */
    case 1514:  /* aarch64_srsra_nv4hi */
    case 1513:  /* aarch64_usra_nv4hi */
    case 1512:  /* aarch64_ssra_nv4hi */
    case 1511:  /* aarch64_ursra_nv16qi */
    case 1510:  /* aarch64_srsra_nv16qi */
    case 1509:  /* aarch64_usra_nv16qi */
    case 1508:  /* aarch64_ssra_nv16qi */
    case 1507:  /* aarch64_ursra_nv8qi */
    case 1506:  /* aarch64_srsra_nv8qi */
    case 1505:  /* aarch64_usra_nv8qi */
    case 1504:  /* aarch64_ssra_nv8qi */
    case 1213:  /* aarch64_rsubhn2v2di */
    case 1212:  /* aarch64_subhn2v2di */
    case 1211:  /* aarch64_raddhn2v2di */
    case 1210:  /* aarch64_addhn2v2di */
    case 1209:  /* aarch64_rsubhn2v4si */
    case 1208:  /* aarch64_subhn2v4si */
    case 1207:  /* aarch64_raddhn2v4si */
    case 1206:  /* aarch64_addhn2v4si */
    case 1205:  /* aarch64_rsubhn2v8hi */
    case 1204:  /* aarch64_subhn2v8hi */
    case 1203:  /* aarch64_raddhn2v8hi */
    case 1202:  /* aarch64_addhn2v8hi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 1141:  /* aarch64_usubw2v4si_internal */
    case 1140:  /* aarch64_uaddw2v4si_internal */
    case 1139:  /* aarch64_ssubw2v4si_internal */
    case 1138:  /* aarch64_saddw2v4si_internal */
    case 1137:  /* aarch64_usubw2v8hi_internal */
    case 1136:  /* aarch64_uaddw2v8hi_internal */
    case 1135:  /* aarch64_ssubw2v8hi_internal */
    case 1134:  /* aarch64_saddw2v8hi_internal */
    case 1133:  /* aarch64_usubw2v16qi_internal */
    case 1132:  /* aarch64_uaddw2v16qi_internal */
    case 1131:  /* aarch64_ssubw2v16qi_internal */
    case 1130:  /* aarch64_saddw2v16qi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      break;

    case 1068:  /* aarch64_simd_bslv2df_internal */
    case 1067:  /* aarch64_simd_bslv4sf_internal */
    case 1066:  /* aarch64_simd_bslv2sf_internal */
    case 1065:  /* aarch64_simd_bslv2di_internal */
    case 1064:  /* aarch64_simd_bslv4si_internal */
    case 1063:  /* aarch64_simd_bslv2si_internal */
    case 1062:  /* aarch64_simd_bslv8hi_internal */
    case 1061:  /* aarch64_simd_bslv4hi_internal */
    case 1060:  /* aarch64_simd_bslv16qi_internal */
    case 1059:  /* aarch64_simd_bslv8qi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1105:  /* aarch64_usubl2v4si_internal */
    case 1104:  /* aarch64_uaddl2v4si_internal */
    case 1103:  /* aarch64_ssubl2v4si_internal */
    case 1102:  /* aarch64_saddl2v4si_internal */
    case 1101:  /* aarch64_usubl2v8hi_internal */
    case 1100:  /* aarch64_uaddl2v8hi_internal */
    case 1099:  /* aarch64_ssubl2v8hi_internal */
    case 1098:  /* aarch64_saddl2v8hi_internal */
    case 1097:  /* aarch64_usubl2v16qi_internal */
    case 1096:  /* aarch64_uaddl2v16qi_internal */
    case 1095:  /* aarch64_ssubl2v16qi_internal */
    case 1094:  /* aarch64_saddl2v16qi_internal */
    case 926:  /* aarch64_simd_vec_umult_hi_v4si */
    case 925:  /* aarch64_simd_vec_smult_hi_v4si */
    case 924:  /* aarch64_simd_vec_umult_hi_v8hi */
    case 923:  /* aarch64_simd_vec_smult_hi_v8hi */
    case 922:  /* aarch64_simd_vec_umult_hi_v16qi */
    case 921:  /* aarch64_simd_vec_smult_hi_v16qi */
    case 920:  /* aarch64_simd_vec_umult_lo_v4si */
    case 919:  /* aarch64_simd_vec_smult_lo_v4si */
    case 918:  /* aarch64_simd_vec_umult_lo_v8hi */
    case 917:  /* aarch64_simd_vec_smult_lo_v8hi */
    case 916:  /* aarch64_simd_vec_umult_lo_v16qi */
    case 915:  /* aarch64_simd_vec_smult_lo_v16qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1);
      recog_data.dup_num[0] = 3;
      break;

    case 896:  /* aarch64_simd_move_hi_quad_v2df */
    case 895:  /* aarch64_simd_move_hi_quad_v4sf */
    case 894:  /* aarch64_simd_move_hi_quad_v2di */
    case 893:  /* aarch64_simd_move_hi_quad_v4si */
    case 892:  /* aarch64_simd_move_hi_quad_v8hi */
    case 891:  /* aarch64_simd_move_hi_quad_v16qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 1012:  /* aarch64_vmlsv2df */
    case 1011:  /* aarch64_vmlsv4sf */
    case 1010:  /* aarch64_vmlsv2sf */
    case 860:  /* aarch64_mlsv4si */
    case 859:  /* aarch64_mlsv2si */
    case 858:  /* aarch64_mlsv8hi */
    case 857:  /* aarch64_mlsv4hi */
    case 856:  /* aarch64_mlsv16qi */
    case 855:  /* aarch64_mlsv8qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 854:  /* aarch64_mlav4si */
    case 853:  /* aarch64_mlav2si */
    case 852:  /* aarch64_mlav8hi */
    case 851:  /* aarch64_mlav4hi */
    case 850:  /* aarch64_mlav16qi */
    case 849:  /* aarch64_mlav8qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 848:  /* aarch64_simd_vec_setv2df */
    case 847:  /* aarch64_simd_vec_setv4sf */
    case 846:  /* aarch64_simd_vec_setv2sf */
    case 845:  /* aarch64_simd_vec_setv2di */
    case 802:  /* aarch64_simd_vec_setv4si */
    case 801:  /* aarch64_simd_vec_setv2si */
    case 800:  /* aarch64_simd_vec_setv8hi */
    case 799:  /* aarch64_simd_vec_setv4hi */
    case 798:  /* aarch64_simd_vec_setv16qi */
    case 797:  /* aarch64_simd_vec_setv8qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1084:  /* aarch64_get_lanev2df */
    case 1083:  /* aarch64_get_lanev4sf */
    case 1082:  /* aarch64_get_lanev2sf */
    case 690:  /* aarch64_dup_lanedi */
    case 689:  /* aarch64_dup_lanesi */
    case 688:  /* aarch64_dup_lanehi */
    case 687:  /* aarch64_dup_laneqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 1081:  /* aarch64_get_lane_unsignedv2di */
    case 1080:  /* aarch64_get_lane_unsignedv4si */
    case 1079:  /* aarch64_get_lane_unsignedv2si */
    case 1078:  /* aarch64_get_lane_unsignedv8hi */
    case 1077:  /* aarch64_get_lane_unsignedv4hi */
    case 1076:  /* aarch64_get_lane_unsignedv16qi */
    case 1075:  /* aarch64_get_lane_unsignedv8qi */
    case 1074:  /* aarch64_get_lane_signedv4si */
    case 1073:  /* aarch64_get_lane_signedv2si */
    case 1072:  /* aarch64_get_lane_signedv8hi */
    case 1071:  /* aarch64_get_lane_signedv4hi */
    case 1070:  /* aarch64_get_lane_signedv16qi */
    case 1069:  /* aarch64_get_lane_signedv8qi */
    case 686:  /* aarch64_dup_lanev2di */
    case 685:  /* aarch64_dup_lanev4si */
    case 684:  /* aarch64_dup_lanev2si */
    case 683:  /* aarch64_dup_lanev8hi */
    case 682:  /* aarch64_dup_lanev4hi */
    case 681:  /* aarch64_dup_lanev16qi */
    case 680:  /* aarch64_dup_lanev8qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 0));
      break;

    case 672:  /* stack_tie */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 671:  /* tlsdesc_small */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 668:  /* *tlsgd_small */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      break;

    case 667:  /* aarch64_load_tp_hard */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 666:  /* ldr_got_small */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 1));
      break;

    case 662:  /* aarch64_movtihigh_di */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 2022:  /* aarch64_load_exclusivedi */
    case 2021:  /* aarch64_load_exclusivesi */
    case 2018:  /* atomic_storedi */
    case 2017:  /* atomic_storesi */
    case 2016:  /* atomic_storehi */
    case 2015:  /* atomic_storeqi */
    case 2014:  /* atomic_loaddi */
    case 2013:  /* atomic_loadsi */
    case 2012:  /* atomic_loadhi */
    case 2011:  /* atomic_loadqi */
    case 1930:  /* aarch64_frecpsv2df */
    case 1929:  /* aarch64_frecpsv4sf */
    case 1928:  /* aarch64_frecpsv2sf */
    case 1895:  /* aarch64_uzp2v2df */
    case 1894:  /* aarch64_uzp1v2df */
    case 1893:  /* aarch64_trn2v2df */
    case 1892:  /* aarch64_trn1v2df */
    case 1891:  /* aarch64_zip2v2df */
    case 1890:  /* aarch64_zip1v2df */
    case 1889:  /* aarch64_uzp2v4sf */
    case 1888:  /* aarch64_uzp1v4sf */
    case 1887:  /* aarch64_trn2v4sf */
    case 1886:  /* aarch64_trn1v4sf */
    case 1885:  /* aarch64_zip2v4sf */
    case 1884:  /* aarch64_zip1v4sf */
    case 1883:  /* aarch64_uzp2v2sf */
    case 1882:  /* aarch64_uzp1v2sf */
    case 1881:  /* aarch64_trn2v2sf */
    case 1880:  /* aarch64_trn1v2sf */
    case 1879:  /* aarch64_zip2v2sf */
    case 1878:  /* aarch64_zip1v2sf */
    case 1877:  /* aarch64_uzp2v2di */
    case 1876:  /* aarch64_uzp1v2di */
    case 1875:  /* aarch64_trn2v2di */
    case 1874:  /* aarch64_trn1v2di */
    case 1873:  /* aarch64_zip2v2di */
    case 1872:  /* aarch64_zip1v2di */
    case 1871:  /* aarch64_uzp2v4si */
    case 1870:  /* aarch64_uzp1v4si */
    case 1869:  /* aarch64_trn2v4si */
    case 1868:  /* aarch64_trn1v4si */
    case 1867:  /* aarch64_zip2v4si */
    case 1866:  /* aarch64_zip1v4si */
    case 1865:  /* aarch64_uzp2v2si */
    case 1864:  /* aarch64_uzp1v2si */
    case 1863:  /* aarch64_trn2v2si */
    case 1862:  /* aarch64_trn1v2si */
    case 1861:  /* aarch64_zip2v2si */
    case 1860:  /* aarch64_zip1v2si */
    case 1859:  /* aarch64_uzp2v8hi */
    case 1858:  /* aarch64_uzp1v8hi */
    case 1857:  /* aarch64_trn2v8hi */
    case 1856:  /* aarch64_trn1v8hi */
    case 1855:  /* aarch64_zip2v8hi */
    case 1854:  /* aarch64_zip1v8hi */
    case 1853:  /* aarch64_uzp2v4hi */
    case 1852:  /* aarch64_uzp1v4hi */
    case 1851:  /* aarch64_trn2v4hi */
    case 1850:  /* aarch64_trn1v4hi */
    case 1849:  /* aarch64_zip2v4hi */
    case 1848:  /* aarch64_zip1v4hi */
    case 1847:  /* aarch64_uzp2v16qi */
    case 1846:  /* aarch64_uzp1v16qi */
    case 1845:  /* aarch64_trn2v16qi */
    case 1844:  /* aarch64_trn1v16qi */
    case 1843:  /* aarch64_zip2v16qi */
    case 1842:  /* aarch64_zip1v16qi */
    case 1841:  /* aarch64_uzp2v8qi */
    case 1840:  /* aarch64_uzp1v8qi */
    case 1839:  /* aarch64_trn2v8qi */
    case 1838:  /* aarch64_trn1v8qi */
    case 1837:  /* aarch64_zip2v8qi */
    case 1836:  /* aarch64_zip1v8qi */
    case 1835:  /* aarch64_combinev16qi */
    case 1834:  /* aarch64_tbl2v16qi */
    case 1833:  /* aarch64_tbl1v16qi */
    case 1832:  /* aarch64_tbl1v8qi */
    case 1771:  /* aarch64_fminv2df */
    case 1770:  /* aarch64_fmaxv2df */
    case 1769:  /* aarch64_fminv4sf */
    case 1768:  /* aarch64_fmaxv4sf */
    case 1767:  /* aarch64_fminv2sf */
    case 1766:  /* aarch64_fmaxv2sf */
    case 1764:  /* aarch64_addpv2si */
    case 1763:  /* aarch64_addpv4hi */
    case 1762:  /* aarch64_addpv8qi */
    case 1636:  /* aarch64_uqrshrn_ndi */
    case 1635:  /* aarch64_sqrshrn_ndi */
    case 1634:  /* aarch64_uqshrn_ndi */
    case 1633:  /* aarch64_sqshrn_ndi */
    case 1632:  /* aarch64_sqrshrun_ndi */
    case 1631:  /* aarch64_sqshrun_ndi */
    case 1630:  /* aarch64_uqrshrn_nsi */
    case 1629:  /* aarch64_sqrshrn_nsi */
    case 1628:  /* aarch64_uqshrn_nsi */
    case 1627:  /* aarch64_sqshrn_nsi */
    case 1626:  /* aarch64_sqrshrun_nsi */
    case 1625:  /* aarch64_sqshrun_nsi */
    case 1624:  /* aarch64_uqrshrn_nhi */
    case 1623:  /* aarch64_sqrshrn_nhi */
    case 1622:  /* aarch64_uqshrn_nhi */
    case 1621:  /* aarch64_sqshrn_nhi */
    case 1620:  /* aarch64_sqrshrun_nhi */
    case 1619:  /* aarch64_sqshrun_nhi */
    case 1618:  /* aarch64_uqrshrn_nv2di */
    case 1617:  /* aarch64_sqrshrn_nv2di */
    case 1616:  /* aarch64_uqshrn_nv2di */
    case 1615:  /* aarch64_sqshrn_nv2di */
    case 1614:  /* aarch64_sqrshrun_nv2di */
    case 1613:  /* aarch64_sqshrun_nv2di */
    case 1612:  /* aarch64_uqrshrn_nv4si */
    case 1611:  /* aarch64_sqrshrn_nv4si */
    case 1610:  /* aarch64_uqshrn_nv4si */
    case 1609:  /* aarch64_sqshrn_nv4si */
    case 1608:  /* aarch64_sqrshrun_nv4si */
    case 1607:  /* aarch64_sqshrun_nv4si */
    case 1606:  /* aarch64_uqrshrn_nv8hi */
    case 1605:  /* aarch64_sqrshrn_nv8hi */
    case 1604:  /* aarch64_uqshrn_nv8hi */
    case 1603:  /* aarch64_sqshrn_nv8hi */
    case 1602:  /* aarch64_sqrshrun_nv8hi */
    case 1601:  /* aarch64_sqshrun_nv8hi */
    case 1600:  /* aarch64_uqshl_ndi */
    case 1599:  /* aarch64_sqshl_ndi */
    case 1598:  /* aarch64_sqshlu_ndi */
    case 1597:  /* aarch64_uqshl_nsi */
    case 1596:  /* aarch64_sqshl_nsi */
    case 1595:  /* aarch64_sqshlu_nsi */
    case 1594:  /* aarch64_uqshl_nhi */
    case 1593:  /* aarch64_sqshl_nhi */
    case 1592:  /* aarch64_sqshlu_nhi */
    case 1591:  /* aarch64_uqshl_nqi */
    case 1590:  /* aarch64_sqshl_nqi */
    case 1589:  /* aarch64_sqshlu_nqi */
    case 1588:  /* aarch64_uqshl_nv2di */
    case 1587:  /* aarch64_sqshl_nv2di */
    case 1586:  /* aarch64_sqshlu_nv2di */
    case 1585:  /* aarch64_uqshl_nv4si */
    case 1584:  /* aarch64_sqshl_nv4si */
    case 1583:  /* aarch64_sqshlu_nv4si */
    case 1582:  /* aarch64_uqshl_nv2si */
    case 1581:  /* aarch64_sqshl_nv2si */
    case 1580:  /* aarch64_sqshlu_nv2si */
    case 1579:  /* aarch64_uqshl_nv8hi */
    case 1578:  /* aarch64_sqshl_nv8hi */
    case 1577:  /* aarch64_sqshlu_nv8hi */
    case 1576:  /* aarch64_uqshl_nv4hi */
    case 1575:  /* aarch64_sqshl_nv4hi */
    case 1574:  /* aarch64_sqshlu_nv4hi */
    case 1573:  /* aarch64_uqshl_nv16qi */
    case 1572:  /* aarch64_sqshl_nv16qi */
    case 1571:  /* aarch64_sqshlu_nv16qi */
    case 1570:  /* aarch64_uqshl_nv8qi */
    case 1569:  /* aarch64_sqshl_nv8qi */
    case 1568:  /* aarch64_sqshlu_nv8qi */
    case 1503:  /* aarch64_urshr_ndi */
    case 1502:  /* aarch64_srshr_ndi */
    case 1501:  /* aarch64_urshr_nv2di */
    case 1500:  /* aarch64_srshr_nv2di */
    case 1499:  /* aarch64_urshr_nv4si */
    case 1498:  /* aarch64_srshr_nv4si */
    case 1497:  /* aarch64_urshr_nv2si */
    case 1496:  /* aarch64_srshr_nv2si */
    case 1495:  /* aarch64_urshr_nv8hi */
    case 1494:  /* aarch64_srshr_nv8hi */
    case 1493:  /* aarch64_urshr_nv4hi */
    case 1492:  /* aarch64_srshr_nv4hi */
    case 1491:  /* aarch64_urshr_nv16qi */
    case 1490:  /* aarch64_srshr_nv16qi */
    case 1489:  /* aarch64_urshr_nv8qi */
    case 1488:  /* aarch64_srshr_nv8qi */
    case 1487:  /* aarch64_ushll2_nv4si */
    case 1486:  /* aarch64_sshll2_nv4si */
    case 1485:  /* aarch64_ushll2_nv8hi */
    case 1484:  /* aarch64_sshll2_nv8hi */
    case 1483:  /* aarch64_ushll2_nv16qi */
    case 1482:  /* aarch64_sshll2_nv16qi */
    case 1481:  /* aarch64_ushll_nv2si */
    case 1480:  /* aarch64_sshll_nv2si */
    case 1479:  /* aarch64_ushll_nv4hi */
    case 1478:  /* aarch64_sshll_nv4hi */
    case 1477:  /* aarch64_ushll_nv8qi */
    case 1476:  /* aarch64_sshll_nv8qi */
    case 1475:  /* aarch64_uqrshldi */
    case 1474:  /* aarch64_sqrshldi */
    case 1473:  /* aarch64_uqshldi */
    case 1472:  /* aarch64_sqshldi */
    case 1471:  /* aarch64_uqrshlsi */
    case 1470:  /* aarch64_sqrshlsi */
    case 1469:  /* aarch64_uqshlsi */
    case 1468:  /* aarch64_sqshlsi */
    case 1467:  /* aarch64_uqrshlhi */
    case 1466:  /* aarch64_sqrshlhi */
    case 1465:  /* aarch64_uqshlhi */
    case 1464:  /* aarch64_sqshlhi */
    case 1463:  /* aarch64_uqrshlqi */
    case 1462:  /* aarch64_sqrshlqi */
    case 1461:  /* aarch64_uqshlqi */
    case 1460:  /* aarch64_sqshlqi */
    case 1459:  /* aarch64_uqrshlv2di */
    case 1458:  /* aarch64_sqrshlv2di */
    case 1457:  /* aarch64_uqshlv2di */
    case 1456:  /* aarch64_sqshlv2di */
    case 1455:  /* aarch64_uqrshlv4si */
    case 1454:  /* aarch64_sqrshlv4si */
    case 1453:  /* aarch64_uqshlv4si */
    case 1452:  /* aarch64_sqshlv4si */
    case 1451:  /* aarch64_uqrshlv2si */
    case 1450:  /* aarch64_sqrshlv2si */
    case 1449:  /* aarch64_uqshlv2si */
    case 1448:  /* aarch64_sqshlv2si */
    case 1447:  /* aarch64_uqrshlv8hi */
    case 1446:  /* aarch64_sqrshlv8hi */
    case 1445:  /* aarch64_uqshlv8hi */
    case 1444:  /* aarch64_sqshlv8hi */
    case 1443:  /* aarch64_uqrshlv4hi */
    case 1442:  /* aarch64_sqrshlv4hi */
    case 1441:  /* aarch64_uqshlv4hi */
    case 1440:  /* aarch64_sqshlv4hi */
    case 1439:  /* aarch64_uqrshlv16qi */
    case 1438:  /* aarch64_sqrshlv16qi */
    case 1437:  /* aarch64_uqshlv16qi */
    case 1436:  /* aarch64_sqshlv16qi */
    case 1435:  /* aarch64_uqrshlv8qi */
    case 1434:  /* aarch64_sqrshlv8qi */
    case 1433:  /* aarch64_uqshlv8qi */
    case 1432:  /* aarch64_sqshlv8qi */
    case 1431:  /* aarch64_urshldi */
    case 1430:  /* aarch64_srshldi */
    case 1429:  /* aarch64_ushldi */
    case 1428:  /* aarch64_sshldi */
    case 1427:  /* aarch64_urshlv2di */
    case 1426:  /* aarch64_srshlv2di */
    case 1425:  /* aarch64_ushlv2di */
    case 1424:  /* aarch64_sshlv2di */
    case 1423:  /* aarch64_urshlv4si */
    case 1422:  /* aarch64_srshlv4si */
    case 1421:  /* aarch64_ushlv4si */
    case 1420:  /* aarch64_sshlv4si */
    case 1419:  /* aarch64_urshlv2si */
    case 1418:  /* aarch64_srshlv2si */
    case 1417:  /* aarch64_ushlv2si */
    case 1416:  /* aarch64_sshlv2si */
    case 1415:  /* aarch64_urshlv8hi */
    case 1414:  /* aarch64_srshlv8hi */
    case 1413:  /* aarch64_ushlv8hi */
    case 1412:  /* aarch64_sshlv8hi */
    case 1411:  /* aarch64_urshlv4hi */
    case 1410:  /* aarch64_srshlv4hi */
    case 1409:  /* aarch64_ushlv4hi */
    case 1408:  /* aarch64_sshlv4hi */
    case 1407:  /* aarch64_urshlv16qi */
    case 1406:  /* aarch64_srshlv16qi */
    case 1405:  /* aarch64_ushlv16qi */
    case 1404:  /* aarch64_sshlv16qi */
    case 1403:  /* aarch64_urshlv8qi */
    case 1402:  /* aarch64_srshlv8qi */
    case 1401:  /* aarch64_ushlv8qi */
    case 1400:  /* aarch64_sshlv8qi */
    case 1331:  /* aarch64_sqrdmulhsi */
    case 1330:  /* aarch64_sqdmulhsi */
    case 1329:  /* aarch64_sqrdmulhhi */
    case 1328:  /* aarch64_sqdmulhhi */
    case 1327:  /* aarch64_sqrdmulhv4si */
    case 1326:  /* aarch64_sqdmulhv4si */
    case 1325:  /* aarch64_sqrdmulhv2si */
    case 1324:  /* aarch64_sqdmulhv2si */
    case 1323:  /* aarch64_sqrdmulhv8hi */
    case 1322:  /* aarch64_sqdmulhv8hi */
    case 1321:  /* aarch64_sqrdmulhv4hi */
    case 1320:  /* aarch64_sqdmulhv4hi */
    case 1281:  /* aarch64_usqadddi */
    case 1280:  /* aarch64_suqadddi */
    case 1279:  /* aarch64_usqaddsi */
    case 1278:  /* aarch64_suqaddsi */
    case 1277:  /* aarch64_usqaddhi */
    case 1276:  /* aarch64_suqaddhi */
    case 1275:  /* aarch64_usqaddqi */
    case 1274:  /* aarch64_suqaddqi */
    case 1273:  /* aarch64_usqaddv2di */
    case 1272:  /* aarch64_suqaddv2di */
    case 1271:  /* aarch64_usqaddv4si */
    case 1270:  /* aarch64_suqaddv4si */
    case 1269:  /* aarch64_usqaddv2si */
    case 1268:  /* aarch64_suqaddv2si */
    case 1267:  /* aarch64_usqaddv8hi */
    case 1266:  /* aarch64_suqaddv8hi */
    case 1265:  /* aarch64_usqaddv4hi */
    case 1264:  /* aarch64_suqaddv4hi */
    case 1263:  /* aarch64_usqaddv16qi */
    case 1262:  /* aarch64_suqaddv16qi */
    case 1261:  /* aarch64_usqaddv8qi */
    case 1260:  /* aarch64_suqaddv8qi */
    case 1215:  /* aarch64_pmulv16qi */
    case 1214:  /* aarch64_pmulv8qi */
    case 1201:  /* aarch64_rsubhnv2di */
    case 1200:  /* aarch64_subhnv2di */
    case 1199:  /* aarch64_raddhnv2di */
    case 1198:  /* aarch64_addhnv2di */
    case 1197:  /* aarch64_rsubhnv4si */
    case 1196:  /* aarch64_subhnv4si */
    case 1195:  /* aarch64_raddhnv4si */
    case 1194:  /* aarch64_addhnv4si */
    case 1193:  /* aarch64_rsubhnv8hi */
    case 1192:  /* aarch64_subhnv8hi */
    case 1191:  /* aarch64_raddhnv8hi */
    case 1190:  /* aarch64_addhnv8hi */
    case 1189:  /* aarch64_urhsubv4si */
    case 1188:  /* aarch64_srhsubv4si */
    case 1187:  /* aarch64_uhsubv4si */
    case 1186:  /* aarch64_shsubv4si */
    case 1185:  /* aarch64_urhaddv4si */
    case 1184:  /* aarch64_srhaddv4si */
    case 1183:  /* aarch64_uhaddv4si */
    case 1182:  /* aarch64_shaddv4si */
    case 1181:  /* aarch64_urhsubv2si */
    case 1180:  /* aarch64_srhsubv2si */
    case 1179:  /* aarch64_uhsubv2si */
    case 1178:  /* aarch64_shsubv2si */
    case 1177:  /* aarch64_urhaddv2si */
    case 1176:  /* aarch64_srhaddv2si */
    case 1175:  /* aarch64_uhaddv2si */
    case 1174:  /* aarch64_shaddv2si */
    case 1173:  /* aarch64_urhsubv8hi */
    case 1172:  /* aarch64_srhsubv8hi */
    case 1171:  /* aarch64_uhsubv8hi */
    case 1170:  /* aarch64_shsubv8hi */
    case 1169:  /* aarch64_urhaddv8hi */
    case 1168:  /* aarch64_srhaddv8hi */
    case 1167:  /* aarch64_uhaddv8hi */
    case 1166:  /* aarch64_shaddv8hi */
    case 1165:  /* aarch64_urhsubv4hi */
    case 1164:  /* aarch64_srhsubv4hi */
    case 1163:  /* aarch64_uhsubv4hi */
    case 1162:  /* aarch64_shsubv4hi */
    case 1161:  /* aarch64_urhaddv4hi */
    case 1160:  /* aarch64_srhaddv4hi */
    case 1159:  /* aarch64_uhaddv4hi */
    case 1158:  /* aarch64_shaddv4hi */
    case 1157:  /* aarch64_urhsubv16qi */
    case 1156:  /* aarch64_srhsubv16qi */
    case 1155:  /* aarch64_uhsubv16qi */
    case 1154:  /* aarch64_shsubv16qi */
    case 1153:  /* aarch64_urhaddv16qi */
    case 1152:  /* aarch64_srhaddv16qi */
    case 1151:  /* aarch64_uhaddv16qi */
    case 1150:  /* aarch64_shaddv16qi */
    case 1149:  /* aarch64_urhsubv8qi */
    case 1148:  /* aarch64_srhsubv8qi */
    case 1147:  /* aarch64_uhsubv8qi */
    case 1146:  /* aarch64_shsubv8qi */
    case 1145:  /* aarch64_urhaddv8qi */
    case 1144:  /* aarch64_srhaddv8qi */
    case 1143:  /* aarch64_uhaddv8qi */
    case 1142:  /* aarch64_shaddv8qi */
    case 844:  /* aarch64_simd_reg_shlv2di_signed */
    case 843:  /* aarch64_simd_reg_shlv4si_signed */
    case 842:  /* aarch64_simd_reg_shlv2si_signed */
    case 841:  /* aarch64_simd_reg_shlv8hi_signed */
    case 840:  /* aarch64_simd_reg_shlv4hi_signed */
    case 839:  /* aarch64_simd_reg_shlv16qi_signed */
    case 838:  /* aarch64_simd_reg_shlv8qi_signed */
    case 837:  /* aarch64_simd_reg_shlv2di_unsigned */
    case 836:  /* aarch64_simd_reg_shlv4si_unsigned */
    case 835:  /* aarch64_simd_reg_shlv2si_unsigned */
    case 834:  /* aarch64_simd_reg_shlv8hi_unsigned */
    case 833:  /* aarch64_simd_reg_shlv4hi_unsigned */
    case 832:  /* aarch64_simd_reg_shlv16qi_unsigned */
    case 831:  /* aarch64_simd_reg_shlv8qi_unsigned */
    case 670:  /* tlsle_small */
    case 659:  /* aarch64_frecpsdf */
    case 658:  /* aarch64_frecpssf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 615:  /* *fnmadddf4 */
    case 614:  /* *fnmaddsf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 613:  /* fnmsdf4 */
    case 612:  /* fnmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 611:  /* fmsdf4 */
    case 610:  /* fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 609:  /* fnmadf4 */
    case 608:  /* fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 998:  /* lfrintnuv2dfv2di2 */
    case 997:  /* lrounduv2dfv2di2 */
    case 996:  /* lflooruv2dfv2di2 */
    case 995:  /* lceiluv2dfv2di2 */
    case 994:  /* lbtruncuv2dfv2di2 */
    case 993:  /* lfrintnv2dfv2di2 */
    case 992:  /* lroundv2dfv2di2 */
    case 991:  /* lfloorv2dfv2di2 */
    case 990:  /* lceilv2dfv2di2 */
    case 989:  /* lbtruncv2dfv2di2 */
    case 988:  /* lfrintnuv4sfv4si2 */
    case 987:  /* lrounduv4sfv4si2 */
    case 986:  /* lflooruv4sfv4si2 */
    case 985:  /* lceiluv4sfv4si2 */
    case 984:  /* lbtruncuv4sfv4si2 */
    case 983:  /* lfrintnv4sfv4si2 */
    case 982:  /* lroundv4sfv4si2 */
    case 981:  /* lfloorv4sfv4si2 */
    case 980:  /* lceilv4sfv4si2 */
    case 979:  /* lbtruncv4sfv4si2 */
    case 978:  /* lfrintnuv2sfv2si2 */
    case 977:  /* lrounduv2sfv2si2 */
    case 976:  /* lflooruv2sfv2si2 */
    case 975:  /* lceiluv2sfv2si2 */
    case 974:  /* lbtruncuv2sfv2si2 */
    case 973:  /* lfrintnv2sfv2si2 */
    case 972:  /* lroundv2sfv2si2 */
    case 971:  /* lfloorv2sfv2si2 */
    case 970:  /* lceilv2sfv2si2 */
    case 969:  /* lbtruncv2sfv2si2 */
    case 605:  /* lfrintnudfdi2 */
    case 604:  /* lroundudfdi2 */
    case 603:  /* lfloorudfdi2 */
    case 602:  /* lceiludfdi2 */
    case 601:  /* lbtruncudfdi2 */
    case 600:  /* lfrintndfdi2 */
    case 599:  /* lrounddfdi2 */
    case 598:  /* lfloordfdi2 */
    case 597:  /* lceildfdi2 */
    case 596:  /* lbtruncdfdi2 */
    case 595:  /* lfrintnudfsi2 */
    case 594:  /* lroundudfsi2 */
    case 593:  /* lfloorudfsi2 */
    case 592:  /* lceiludfsi2 */
    case 591:  /* lbtruncudfsi2 */
    case 590:  /* lfrintndfsi2 */
    case 589:  /* lrounddfsi2 */
    case 588:  /* lfloordfsi2 */
    case 587:  /* lceildfsi2 */
    case 586:  /* lbtruncdfsi2 */
    case 585:  /* lfrintnusfdi2 */
    case 584:  /* lroundusfdi2 */
    case 583:  /* lfloorusfdi2 */
    case 582:  /* lceilusfdi2 */
    case 581:  /* lbtruncusfdi2 */
    case 580:  /* lfrintnsfdi2 */
    case 579:  /* lroundsfdi2 */
    case 578:  /* lfloorsfdi2 */
    case 577:  /* lceilsfdi2 */
    case 576:  /* lbtruncsfdi2 */
    case 575:  /* lfrintnusfsi2 */
    case 574:  /* lroundusfsi2 */
    case 573:  /* lfloorusfsi2 */
    case 572:  /* lceilusfsi2 */
    case 571:  /* lbtruncusfsi2 */
    case 570:  /* lfrintnsfsi2 */
    case 569:  /* lroundsfsi2 */
    case 568:  /* lfloorsfsi2 */
    case 567:  /* lceilsfsi2 */
    case 566:  /* lbtruncsfsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      break;

    case 947:  /* fmav2df4 */
    case 946:  /* fmav4sf4 */
    case 945:  /* fmav2sf4 */
    case 607:  /* fmadf4 */
    case 606:  /* fmasf4 */
    case 533:  /* *extzvdi */
    case 532:  /* *extvdi */
    case 531:  /* *extzvsi */
    case 530:  /* *extvsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 510:  /* *extrsi5_insn_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 1));
      break;

    case 509:  /* *extrdi5_insn */
    case 508:  /* *extrsi5_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 487:  /* *and_rotrdi3nr_compare0 */
    case 486:  /* *and_lshrdi3nr_compare0 */
    case 485:  /* *and_ashrdi3nr_compare0 */
    case 484:  /* *and_ashldi3nr_compare0 */
    case 483:  /* *and_rotrsi3nr_compare0 */
    case 482:  /* *and_lshrsi3nr_compare0 */
    case 481:  /* *and_ashrsi3nr_compare0 */
    case 480:  /* *and_ashlsi3nr_compare0 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 1927:  /* aarch64_frecpev2df */
    case 1926:  /* aarch64_frecpev4sf */
    case 1925:  /* aarch64_frecpev2sf */
    case 1913:  /* aarch64_st4df_dreg */
    case 1912:  /* aarch64_st4di_dreg */
    case 1911:  /* aarch64_st4v2sf_dreg */
    case 1910:  /* aarch64_st4v2si_dreg */
    case 1909:  /* aarch64_st4v4hi_dreg */
    case 1908:  /* aarch64_st4v8qi_dreg */
    case 1907:  /* aarch64_st3df_dreg */
    case 1906:  /* aarch64_st3di_dreg */
    case 1905:  /* aarch64_st3v2sf_dreg */
    case 1904:  /* aarch64_st3v2si_dreg */
    case 1903:  /* aarch64_st3v4hi_dreg */
    case 1902:  /* aarch64_st3v8qi_dreg */
    case 1901:  /* aarch64_st2df_dreg */
    case 1900:  /* aarch64_st2di_dreg */
    case 1899:  /* aarch64_st2v2sf_dreg */
    case 1898:  /* aarch64_st2v2si_dreg */
    case 1897:  /* aarch64_st2v4hi_dreg */
    case 1896:  /* aarch64_st2v8qi_dreg */
    case 1810:  /* vec_store_lanesxiv2df */
    case 1809:  /* vec_store_lanesxiv4sf */
    case 1808:  /* vec_store_lanesxiv2di */
    case 1807:  /* vec_store_lanesxiv4si */
    case 1806:  /* vec_store_lanesxiv8hi */
    case 1805:  /* vec_store_lanesxiv16qi */
    case 1804:  /* vec_load_lanesxiv2df */
    case 1803:  /* vec_load_lanesxiv4sf */
    case 1802:  /* vec_load_lanesxiv2di */
    case 1801:  /* vec_load_lanesxiv4si */
    case 1800:  /* vec_load_lanesxiv8hi */
    case 1799:  /* vec_load_lanesxiv16qi */
    case 1798:  /* vec_store_lanesciv2df */
    case 1797:  /* vec_store_lanesciv4sf */
    case 1796:  /* vec_store_lanesciv2di */
    case 1795:  /* vec_store_lanesciv4si */
    case 1794:  /* vec_store_lanesciv8hi */
    case 1793:  /* vec_store_lanesciv16qi */
    case 1792:  /* vec_load_lanesciv2df */
    case 1791:  /* vec_load_lanesciv4sf */
    case 1790:  /* vec_load_lanesciv2di */
    case 1789:  /* vec_load_lanesciv4si */
    case 1788:  /* vec_load_lanesciv8hi */
    case 1787:  /* vec_load_lanesciv16qi */
    case 1786:  /* vec_store_lanesoiv2df */
    case 1785:  /* vec_store_lanesoiv4sf */
    case 1784:  /* vec_store_lanesoiv2di */
    case 1783:  /* vec_store_lanesoiv4si */
    case 1782:  /* vec_store_lanesoiv8hi */
    case 1781:  /* vec_store_lanesoiv16qi */
    case 1780:  /* vec_load_lanesoiv2df */
    case 1779:  /* vec_load_lanesoiv4sf */
    case 1778:  /* vec_load_lanesoiv2di */
    case 1777:  /* vec_load_lanesoiv4si */
    case 1776:  /* vec_load_lanesoiv8hi */
    case 1775:  /* vec_load_lanesoiv16qi */
    case 1765:  /* aarch64_addpdi */
    case 1299:  /* aarch64_uqmovndi */
    case 1298:  /* aarch64_sqmovndi */
    case 1297:  /* aarch64_uqmovnsi */
    case 1296:  /* aarch64_sqmovnsi */
    case 1295:  /* aarch64_uqmovnhi */
    case 1294:  /* aarch64_sqmovnhi */
    case 1293:  /* aarch64_uqmovnv2di */
    case 1292:  /* aarch64_sqmovnv2di */
    case 1291:  /* aarch64_uqmovnv4si */
    case 1290:  /* aarch64_sqmovnv4si */
    case 1289:  /* aarch64_uqmovnv8hi */
    case 1288:  /* aarch64_sqmovnv8hi */
    case 1287:  /* aarch64_sqmovundi */
    case 1286:  /* aarch64_sqmovunsi */
    case 1285:  /* aarch64_sqmovunhi */
    case 1284:  /* aarch64_sqmovunv2di */
    case 1283:  /* aarch64_sqmovunv4si */
    case 1282:  /* aarch64_sqmovunv8hi */
    case 1058:  /* reduc_smin_v2si */
    case 1057:  /* reduc_smax_v2si */
    case 1056:  /* reduc_umin_v2si */
    case 1055:  /* reduc_umax_v2si */
    case 1054:  /* reduc_smin_v4si */
    case 1053:  /* reduc_smax_v4si */
    case 1052:  /* reduc_umin_v4si */
    case 1051:  /* reduc_umax_v4si */
    case 1050:  /* reduc_smin_v8hi */
    case 1049:  /* reduc_smax_v8hi */
    case 1048:  /* reduc_umin_v8hi */
    case 1047:  /* reduc_umax_v8hi */
    case 1046:  /* reduc_smin_v4hi */
    case 1045:  /* reduc_smax_v4hi */
    case 1044:  /* reduc_umin_v4hi */
    case 1043:  /* reduc_umax_v4hi */
    case 1042:  /* reduc_smin_v16qi */
    case 1041:  /* reduc_smax_v16qi */
    case 1040:  /* reduc_umin_v16qi */
    case 1039:  /* reduc_umax_v16qi */
    case 1038:  /* reduc_smin_v8qi */
    case 1037:  /* reduc_smax_v8qi */
    case 1036:  /* reduc_umin_v8qi */
    case 1035:  /* reduc_umax_v8qi */
    case 1034:  /* aarch64_addvv2si */
    case 1033:  /* aarch64_addvv2di */
    case 1032:  /* aarch64_addvv4si */
    case 1031:  /* aarch64_addvv8hi */
    case 1030:  /* aarch64_addvv4hi */
    case 1029:  /* aarch64_addvv16qi */
    case 1028:  /* aarch64_addvv8qi */
    case 1027:  /* aarch64_addvv2df */
    case 1026:  /* aarch64_addvv2sf */
    case 1025:  /* aarch64_addpv4sf */
    case 1024:  /* reduc_smin_v2df */
    case 1023:  /* reduc_smax_v2df */
    case 1022:  /* reduc_smin_v2sf */
    case 1021:  /* reduc_smax_v2sf */
    case 1020:  /* reduc_smin_v4sf */
    case 1019:  /* reduc_smax_v4sf */
    case 968:  /* roundv2df2 */
    case 967:  /* rintv2df2 */
    case 966:  /* nearbyintv2df2 */
    case 965:  /* frintnv2df2 */
    case 964:  /* floorv2df2 */
    case 963:  /* ceilv2df2 */
    case 962:  /* btruncv2df2 */
    case 961:  /* roundv4sf2 */
    case 960:  /* rintv4sf2 */
    case 959:  /* nearbyintv4sf2 */
    case 958:  /* frintnv4sf2 */
    case 957:  /* floorv4sf2 */
    case 956:  /* ceilv4sf2 */
    case 955:  /* btruncv4sf2 */
    case 954:  /* roundv2sf2 */
    case 953:  /* rintv2sf2 */
    case 952:  /* nearbyintv2sf2 */
    case 951:  /* frintnv2sf2 */
    case 950:  /* floorv2sf2 */
    case 949:  /* ceilv2sf2 */
    case 948:  /* btruncv2sf2 */
    case 669:  /* tlsie_small */
    case 657:  /* aarch64_frecpxdf */
    case 656:  /* aarch64_frecpedf */
    case 655:  /* aarch64_frecpxsf */
    case 654:  /* aarch64_frecpesf */
    case 565:  /* rounddf2 */
    case 564:  /* rintdf2 */
    case 563:  /* nearbyintdf2 */
    case 562:  /* frintndf2 */
    case 561:  /* floordf2 */
    case 560:  /* ceildf2 */
    case 559:  /* btruncdf2 */
    case 558:  /* roundsf2 */
    case 557:  /* rintsf2 */
    case 556:  /* nearbyintsf2 */
    case 555:  /* frintnsf2 */
    case 554:  /* floorsf2 */
    case 553:  /* ceilsf2 */
    case 552:  /* btruncsf2 */
    case 477:  /* rbitdi2 */
    case 476:  /* rbitsi2 */
    case 475:  /* clrsbdi2 */
    case 474:  /* clrsbsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 763:  /* abav4si_3 */
    case 762:  /* abav2si_3 */
    case 761:  /* abav8hi_3 */
    case 760:  /* abav4hi_3 */
    case 759:  /* abav16qi_3 */
    case 758:  /* abav8qi_3 */
    case 471:  /* *xor_one_cmpl_rotrdi3 */
    case 470:  /* *xor_one_cmpl_lshrdi3 */
    case 469:  /* *xor_one_cmpl_ashrdi3 */
    case 468:  /* *xor_one_cmpl_ashldi3 */
    case 467:  /* *ior_one_cmpl_rotrdi3 */
    case 466:  /* *ior_one_cmpl_lshrdi3 */
    case 465:  /* *ior_one_cmpl_ashrdi3 */
    case 464:  /* *ior_one_cmpl_ashldi3 */
    case 463:  /* *and_one_cmpl_rotrdi3 */
    case 462:  /* *and_one_cmpl_lshrdi3 */
    case 461:  /* *and_one_cmpl_ashrdi3 */
    case 460:  /* *and_one_cmpl_ashldi3 */
    case 459:  /* *xor_one_cmpl_rotrsi3 */
    case 458:  /* *xor_one_cmpl_lshrsi3 */
    case 457:  /* *xor_one_cmpl_ashrsi3 */
    case 456:  /* *xor_one_cmpl_ashlsi3 */
    case 455:  /* *ior_one_cmpl_rotrsi3 */
    case 454:  /* *ior_one_cmpl_lshrsi3 */
    case 453:  /* *ior_one_cmpl_ashrsi3 */
    case 452:  /* *ior_one_cmpl_ashlsi3 */
    case 451:  /* *and_one_cmpl_rotrsi3 */
    case 450:  /* *and_one_cmpl_lshrsi3 */
    case 449:  /* *and_one_cmpl_ashrsi3 */
    case 448:  /* *and_one_cmpl_ashlsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 395:  /* *and_rotrsi3_compare0_uxtw */
    case 394:  /* *and_lshrsi3_compare0_uxtw */
    case 393:  /* *and_ashrsi3_compare0_uxtw */
    case 392:  /* *and_ashlsi3_compare0_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[2] = 3;
      break;

    case 371:  /* *csneg3di_insn */
    case 370:  /* *csneg3si_insn */
    case 369:  /* *csinv3di_insn */
    case 368:  /* *csinv3si_insn */
    case 367:  /* csinc3di_insn */
    case 366:  /* csinc3si_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 365:  /* *csinc2di_insn */
    case 364:  /* *csinc2si_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 361:  /* *cmovsi_insn_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 363:  /* *cmovdf_insn */
    case 362:  /* *cmovsf_insn */
    case 360:  /* *cmovdi_insn */
    case 359:  /* *cmovsi_insn */
    case 358:  /* *cmovhi_insn */
    case 357:  /* *cmovqi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 356:  /* *cstoresi_neg_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 355:  /* cstoredi_neg */
    case 354:  /* cstoresi_neg */
    case 353:  /* cstorehi_neg */
    case 352:  /* cstoreqi_neg */
    case 351:  /* *cstoresi_insn_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 350:  /* *cstoredi_insn */
    case 349:  /* *cstoresi_insn */
    case 348:  /* *cstorehi_insn */
    case 347:  /* *cstoreqi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 346:  /* *cmp_swp_zero_extendsi_shft_di */
    case 345:  /* *cmp_swp_extendsi_shft_di */
    case 344:  /* *cmp_swp_zero_extendhi_shft_di */
    case 343:  /* *cmp_swp_extendhi_shft_di */
    case 342:  /* *cmp_swp_zero_extendqi_shft_di */
    case 341:  /* *cmp_swp_extendqi_shft_di */
    case 340:  /* *cmp_swp_zero_extendsi_shft_si */
    case 339:  /* *cmp_swp_extendsi_shft_si */
    case 338:  /* *cmp_swp_zero_extendhi_shft_si */
    case 337:  /* *cmp_swp_extendhi_shft_si */
    case 336:  /* *cmp_swp_zero_extendqi_shft_si */
    case 335:  /* *cmp_swp_extendqi_shft_si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 334:  /* *cmp_swp_zero_extendsi_regdi */
    case 333:  /* *cmp_swp_extendsi_regdi */
    case 332:  /* *cmp_swp_zero_extendhi_regdi */
    case 331:  /* *cmp_swp_extendhi_regdi */
    case 330:  /* *cmp_swp_zero_extendqi_regdi */
    case 329:  /* *cmp_swp_extendqi_regdi */
    case 328:  /* *cmp_swp_zero_extendsi_regsi */
    case 327:  /* *cmp_swp_extendsi_regsi */
    case 326:  /* *cmp_swp_zero_extendhi_regsi */
    case 325:  /* *cmp_swp_extendhi_regsi */
    case 324:  /* *cmp_swp_zero_extendqi_regsi */
    case 323:  /* *cmp_swp_extendqi_regsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 322:  /* *cmp_swp_lsr_regdi */
    case 321:  /* *cmp_swp_asr_regdi */
    case 320:  /* *cmp_swp_lsl_regdi */
    case 319:  /* *cmp_swp_lsr_regsi */
    case 318:  /* *cmp_swp_asr_regsi */
    case 317:  /* *cmp_swp_lsl_regsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 316:  /* *cmpedf */
    case 315:  /* *cmpesf */
    case 314:  /* *cmpdf */
    case 313:  /* *cmpsf */
    case 312:  /* *cmpdi */
    case 311:  /* *cmpsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 304:  /* umuldi3_highpart */
    case 303:  /* smuldi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 302:  /* *umulsidi_neg */
    case 301:  /* *mulsidi_neg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 300:  /* umsubsidi4 */
    case 299:  /* msubsidi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 298:  /* umaddsidi4 */
    case 297:  /* maddsidi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1117:  /* aarch64_usublv2si */
    case 1116:  /* aarch64_uaddlv2si */
    case 1115:  /* aarch64_ssublv2si */
    case 1114:  /* aarch64_saddlv2si */
    case 1113:  /* aarch64_usublv4hi */
    case 1112:  /* aarch64_uaddlv4hi */
    case 1111:  /* aarch64_ssublv4hi */
    case 1110:  /* aarch64_saddlv4hi */
    case 1109:  /* aarch64_usublv8qi */
    case 1108:  /* aarch64_uaddlv8qi */
    case 1107:  /* aarch64_ssublv8qi */
    case 1106:  /* aarch64_saddlv8qi */
    case 902:  /* vec_pack_trunc_v2di */
    case 901:  /* vec_pack_trunc_v4si */
    case 900:  /* vec_pack_trunc_v8hi */
    case 296:  /* umulsidi3 */
    case 295:  /* mulsidi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 270:  /* *neg_lsrdi3_compare0 */
    case 269:  /* *neg_asrdi3_compare0 */
    case 268:  /* *neg_lsldi3_compare0 */
    case 267:  /* *neg_lsrsi3_compare0 */
    case 266:  /* *neg_asrsi3_compare0 */
    case 265:  /* *neg_lslsi3_compare0 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 264:  /* *negsi2_compare0_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 263:  /* *negdi2_compare0 */
    case 262:  /* *negsi2_compare0 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 261:  /* *ngcsi_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 260:  /* *ngcdi */
    case 259:  /* *ngcsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1007:  /* vec_unpacks_hi_v4sf */
    case 1005:  /* vec_unpacks_lo_v4sf */
    case 664:  /* aarch64_movtilow_tilow */
    case 661:  /* aarch64_movdi_tihigh */
    case 551:  /* *bswapsi2_uxtw */
    case 258:  /* *negsi2_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 255:  /* *sub_uxtsi_multp2_uxtw */
    case 249:  /* *sub_extzvsi_multp2_uxtw */
    case 248:  /* *sub_extvsi_multp2_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 254:  /* *sub_uxtdi_multp2 */
    case 253:  /* *sub_uxtsi_multp2 */
    case 247:  /* *sub_extzvdi_multp2 */
    case 246:  /* *sub_extvdi_multp2 */
    case 245:  /* *sub_extzvsi_multp2 */
    case 244:  /* *sub_extvsi_multp2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 243:  /* *sub_zero_extendhi_shft_si_uxtw */
    case 242:  /* *sub_extendhi_shft_si_uxtw */
    case 241:  /* *sub_zero_extendqi_shft_si_uxtw */
    case 240:  /* *sub_extendqi_shft_si_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 1));
      break;

    case 239:  /* *sub_zero_extendsi_shft_di */
    case 238:  /* *sub_extendsi_shft_di */
    case 237:  /* *sub_zero_extendhi_shft_di */
    case 236:  /* *sub_extendhi_shft_di */
    case 235:  /* *sub_zero_extendqi_shft_di */
    case 234:  /* *sub_extendqi_shft_di */
    case 233:  /* *sub_zero_extendsi_shft_si */
    case 232:  /* *sub_extendsi_shft_si */
    case 231:  /* *sub_zero_extendhi_shft_si */
    case 230:  /* *sub_extendhi_shft_si */
    case 229:  /* *sub_zero_extendqi_shft_si */
    case 228:  /* *sub_extendqi_shft_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 227:  /* *sub_zero_extendhi_si_uxtw */
    case 226:  /* *sub_extendhi_si_uxtw */
    case 225:  /* *sub_zero_extendqi_si_uxtw */
    case 224:  /* *sub_extendqi_si_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      break;

    case 1129:  /* aarch64_usubwv2si */
    case 1128:  /* aarch64_uaddwv2si */
    case 1127:  /* aarch64_ssubwv2si */
    case 1126:  /* aarch64_saddwv2si */
    case 1125:  /* aarch64_usubwv4hi */
    case 1124:  /* aarch64_uaddwv4hi */
    case 1123:  /* aarch64_ssubwv4hi */
    case 1122:  /* aarch64_saddwv4hi */
    case 1121:  /* aarch64_usubwv8qi */
    case 1120:  /* aarch64_uaddwv8qi */
    case 1119:  /* aarch64_ssubwv8qi */
    case 1118:  /* aarch64_saddwv8qi */
    case 1009:  /* aarch64_float_truncate_hi_v4sf */
    case 223:  /* *sub_zero_extendsi_di */
    case 222:  /* *sub_extendsi_di */
    case 221:  /* *sub_zero_extendhi_di */
    case 220:  /* *sub_extendhi_di */
    case 219:  /* *sub_zero_extendqi_di */
    case 218:  /* *sub_extendqi_di */
    case 217:  /* *sub_zero_extendsi_si */
    case 216:  /* *sub_extendsi_si */
    case 215:  /* *sub_zero_extendhi_si */
    case 214:  /* *sub_extendhi_si */
    case 213:  /* *sub_zero_extendqi_si */
    case 212:  /* *sub_extendqi_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 291:  /* *msubsi_uxtw */
    case 211:  /* *sub_mul_imm_si_uxtw */
    case 208:  /* *sub_lsr_si_uxtw */
    case 207:  /* *sub_asr_si_uxtw */
    case 206:  /* *sub_lsl_si_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 290:  /* *msubdi */
    case 289:  /* *msubsi */
    case 210:  /* *sub_mul_imm_di */
    case 209:  /* *sub_mul_imm_si */
    case 205:  /* *sub_lsr_di */
    case 204:  /* *sub_asr_di */
    case 203:  /* *sub_lsl_di */
    case 202:  /* *sub_lsr_si */
    case 201:  /* *sub_asr_si */
    case 200:  /* *sub_lsl_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 190:  /* *addsi3_carryin_alt3_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 189:  /* *adddi3_carryin_alt3 */
    case 188:  /* *addsi3_carryin_alt3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 187:  /* *addsi3_carryin_alt2_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 186:  /* *adddi3_carryin_alt2 */
    case 185:  /* *addsi3_carryin_alt2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1716:  /* aarch64_cmtstdi */
    case 1715:  /* aarch64_cmtstv2di */
    case 1714:  /* aarch64_cmtstv4si */
    case 1713:  /* aarch64_cmtstv2si */
    case 1712:  /* aarch64_cmtstv8hi */
    case 1711:  /* aarch64_cmtstv4hi */
    case 1710:  /* aarch64_cmtstv16qi */
    case 1709:  /* aarch64_cmtstv8qi */
    case 282:  /* *neg_mul_imm_si2_uxtw */
    case 279:  /* *neg_lsr_si2_uxtw */
    case 278:  /* *neg_asr_si2_uxtw */
    case 277:  /* *neg_lsl_si2_uxtw */
    case 184:  /* *addsi3_carryin_alt1_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 181:  /* *addsi3_carryin_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 1));
      break;

    case 180:  /* *adddi3_carryin */
    case 179:  /* *addsi3_carryin */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 193:  /* *add_uxtsi_multp2_uxtw */
    case 178:  /* *add_extzvsi_multp2_uxtw */
    case 177:  /* *add_extvsi_multp2_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 192:  /* *add_uxtdi_multp2 */
    case 191:  /* *add_uxtsi_multp2 */
    case 176:  /* *add_extzvdi_multp2 */
    case 175:  /* *add_extvdi_multp2 */
    case 174:  /* *add_extzvsi_multp2 */
    case 173:  /* *add_extvsi_multp2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 172:  /* *add_zero_extendhi_mult_si_uxtw */
    case 171:  /* *add_extendhi_mult_si_uxtw */
    case 170:  /* *add_zero_extendqi_mult_si_uxtw */
    case 169:  /* *add_extendqi_mult_si_uxtw */
    case 156:  /* *add_zero_extendhi_shft_si_uxtw */
    case 155:  /* *add_extendhi_shft_si_uxtw */
    case 154:  /* *add_zero_extendqi_shft_si_uxtw */
    case 153:  /* *add_extendqi_shft_si_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 168:  /* *add_zero_extendsi_mult_di */
    case 167:  /* *add_extendsi_mult_di */
    case 166:  /* *add_zero_extendhi_mult_di */
    case 165:  /* *add_extendhi_mult_di */
    case 164:  /* *add_zero_extendqi_mult_di */
    case 163:  /* *add_extendqi_mult_di */
    case 162:  /* *add_zero_extendsi_mult_si */
    case 161:  /* *add_extendsi_mult_si */
    case 160:  /* *add_zero_extendhi_mult_si */
    case 159:  /* *add_extendhi_mult_si */
    case 158:  /* *add_zero_extendqi_mult_si */
    case 157:  /* *add_extendqi_mult_si */
    case 152:  /* *add_zero_extendsi_shft_di */
    case 151:  /* *add_extendsi_shft_di */
    case 150:  /* *add_zero_extendhi_shft_di */
    case 149:  /* *add_extendhi_shft_di */
    case 148:  /* *add_zero_extendqi_shft_di */
    case 147:  /* *add_extendqi_shft_di */
    case 146:  /* *add_zero_extendsi_shft_si */
    case 145:  /* *add_extendsi_shft_si */
    case 144:  /* *add_zero_extendhi_shft_si */
    case 143:  /* *add_extendhi_shft_si */
    case 142:  /* *add_zero_extendqi_shft_si */
    case 141:  /* *add_extendqi_shft_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 294:  /* *mulsi_neg_uxtw */
    case 252:  /* *subsi3_carryin_uxtw */
    case 140:  /* *add_zero_extendhi_si_uxtw */
    case 139:  /* *add_extendhi_si_uxtw */
    case 138:  /* *add_zero_extendqi_si_uxtw */
    case 137:  /* *add_extendqi_si_uxtw */
    case 136:  /* *add_zero_extendhi_si_uxtw */
    case 135:  /* *add_extendhi_si_uxtw */
    case 134:  /* *add_zero_extendqi_si_uxtw */
    case 133:  /* *add_extendqi_si_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 717:  /* bicv2di3 */
    case 716:  /* bicv4si3 */
    case 715:  /* bicv2si3 */
    case 714:  /* bicv8hi3 */
    case 713:  /* bicv4hi3 */
    case 712:  /* bicv16qi3 */
    case 711:  /* bicv8qi3 */
    case 710:  /* ornv2di3 */
    case 709:  /* ornv4si3 */
    case 708:  /* ornv2si3 */
    case 707:  /* ornv8hi3 */
    case 706:  /* ornv4hi3 */
    case 705:  /* ornv16qi3 */
    case 704:  /* ornv8qi3 */
    case 641:  /* *fnmuldf3 */
    case 640:  /* *fnmulsf3 */
    case 545:  /* *zero_extendsi_shft_di */
    case 544:  /* *extendsi_shft_di */
    case 543:  /* *zero_extendhi_shft_di */
    case 542:  /* *extendhi_shft_di */
    case 541:  /* *zero_extendqi_shft_di */
    case 540:  /* *extendqi_shft_di */
    case 539:  /* *zero_extendsi_shft_si */
    case 538:  /* *extendsi_shft_si */
    case 537:  /* *zero_extendhi_shft_si */
    case 536:  /* *extendhi_shft_si */
    case 535:  /* *zero_extendqi_shft_si */
    case 534:  /* *extendqi_shft_si */
    case 447:  /* *xor_one_cmpldi3 */
    case 446:  /* *ior_one_cmpldi3 */
    case 445:  /* *and_one_cmpldi3 */
    case 444:  /* *xor_one_cmplsi3 */
    case 443:  /* *ior_one_cmplsi3 */
    case 442:  /* *and_one_cmplsi3 */
    case 293:  /* *muldi_neg */
    case 292:  /* *mulsi_neg */
    case 251:  /* *subdi3_carryin */
    case 250:  /* *subsi3_carryin */
    case 132:  /* *add_zero_extendsi_di */
    case 131:  /* *add_extendsi_di */
    case 130:  /* *add_zero_extendhi_di */
    case 129:  /* *add_extendhi_di */
    case 128:  /* *add_zero_extendqi_di */
    case 127:  /* *add_extendqi_di */
    case 126:  /* *add_zero_extendsi_si */
    case 125:  /* *add_extendsi_si */
    case 124:  /* *add_zero_extendhi_si */
    case 123:  /* *add_extendhi_si */
    case 122:  /* *add_zero_extendqi_si */
    case 121:  /* *add_extendqi_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 431:  /* *xor_rotrsi3_uxtw */
    case 430:  /* *xor_lshrsi3_uxtw */
    case 429:  /* *xor_ashrsi3_uxtw */
    case 428:  /* *xor_ashlsi3_uxtw */
    case 427:  /* *ior_rotrsi3_uxtw */
    case 426:  /* *ior_lshrsi3_uxtw */
    case 425:  /* *ior_ashrsi3_uxtw */
    case 424:  /* *ior_ashlsi3_uxtw */
    case 423:  /* *and_rotrsi3_uxtw */
    case 422:  /* *and_lshrsi3_uxtw */
    case 421:  /* *and_ashrsi3_uxtw */
    case 420:  /* *and_ashlsi3_uxtw */
    case 288:  /* *maddsi_uxtw */
    case 118:  /* *add_lsr_si_uxtw */
    case 117:  /* *add_asr_si_uxtw */
    case 116:  /* *add_lsl_si_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 547:  /* *andim_ashiftdi_bfiz */
    case 546:  /* *andim_ashiftsi_bfiz */
    case 419:  /* *xor_rotrdi3 */
    case 418:  /* *xor_lshrdi3 */
    case 417:  /* *xor_ashrdi3 */
    case 416:  /* *xor_ashldi3 */
    case 415:  /* *ior_rotrdi3 */
    case 414:  /* *ior_lshrdi3 */
    case 413:  /* *ior_ashrdi3 */
    case 412:  /* *ior_ashldi3 */
    case 411:  /* *and_rotrdi3 */
    case 410:  /* *and_lshrdi3 */
    case 409:  /* *and_ashrdi3 */
    case 408:  /* *and_ashldi3 */
    case 407:  /* *xor_rotrsi3 */
    case 406:  /* *xor_lshrsi3 */
    case 405:  /* *xor_ashrsi3 */
    case 404:  /* *xor_ashlsi3 */
    case 403:  /* *ior_rotrsi3 */
    case 402:  /* *ior_lshrsi3 */
    case 401:  /* *ior_ashrsi3 */
    case 400:  /* *ior_ashlsi3 */
    case 399:  /* *and_rotrsi3 */
    case 398:  /* *and_lshrsi3 */
    case 397:  /* *and_ashrsi3 */
    case 396:  /* *and_ashlsi3 */
    case 287:  /* *madddi */
    case 286:  /* *maddsi */
    case 120:  /* *add_mul_imm_di */
    case 119:  /* *add_mul_imm_si */
    case 115:  /* *add_lsr_di */
    case 114:  /* *add_asr_di */
    case 113:  /* *add_lsl_di */
    case 112:  /* *add_lsr_si */
    case 111:  /* *add_asr_si */
    case 110:  /* *add_lsl_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 109:  /* *compare_negdi */
    case 108:  /* *compare_negsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 479:  /* *anddi3nr_compare0 */
    case 478:  /* *andsi3nr_compare0 */
    case 107:  /* *adddi3nr_compare0 */
    case 106:  /* *addsi3nr_compare0 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 105:  /* *subs_extzvdi_multp2 */
    case 104:  /* *subs_extvdi_multp2 */
    case 103:  /* *subs_extzvsi_multp2 */
    case 102:  /* *subs_extvsi_multp2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 4;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0), 1);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 1);
      recog_data.dup_num[3] = 3;
      break;

    case 101:  /* *adds_extzvdi_multp2 */
    case 100:  /* *adds_extvdi_multp2 */
    case 99:  /* *adds_extzvsi_multp2 */
    case 98:  /* *adds_extvsi_multp2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[2] = 3;
      recog_data.dup_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[3] = 4;
      break;

    case 97:  /* *subs_zero_extendsi_di */
    case 96:  /* *subs_extendsi_di */
    case 95:  /* *subs_zero_extendhi_di */
    case 94:  /* *subs_extendhi_di */
    case 93:  /* *subs_zero_extendqi_di */
    case 92:  /* *subs_extendqi_di */
    case 91:  /* *subs_zero_extendsi_si */
    case 90:  /* *subs_extendsi_si */
    case 89:  /* *subs_zero_extendhi_si */
    case 88:  /* *subs_extendhi_si */
    case 87:  /* *subs_zero_extendqi_si */
    case 86:  /* *subs_extendqi_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 85:  /* *adds_zero_extendsi_di */
    case 84:  /* *adds_extendsi_di */
    case 83:  /* *adds_zero_extendhi_di */
    case 82:  /* *adds_extendhi_di */
    case 81:  /* *adds_zero_extendqi_di */
    case 80:  /* *adds_extendqi_di */
    case 79:  /* *adds_zero_extendsi_si */
    case 78:  /* *adds_extendsi_si */
    case 77:  /* *adds_zero_extendhi_si */
    case 76:  /* *adds_extendhi_si */
    case 75:  /* *adds_zero_extendqi_si */
    case 74:  /* *adds_extendqi_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 73:  /* *subs_mul_imm_di */
    case 72:  /* *subs_mul_imm_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 1);
      recog_data.dup_num[2] = 3;
      break;

    case 391:  /* *and_rotrdi3_compare0 */
    case 390:  /* *and_lshrdi3_compare0 */
    case 389:  /* *and_ashrdi3_compare0 */
    case 388:  /* *and_ashldi3_compare0 */
    case 387:  /* *and_rotrsi3_compare0 */
    case 386:  /* *and_lshrsi3_compare0 */
    case 385:  /* *and_ashrsi3_compare0 */
    case 384:  /* *and_ashlsi3_compare0 */
    case 71:  /* *adds_mul_imm_di */
    case 70:  /* *adds_mul_imm_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 3;
      break;

    case 383:  /* *andsi3_compare0_uxtw */
    case 199:  /* *subsi3_compare0_uxtw */
    case 69:  /* *addsi3_compare0_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 382:  /* *anddi3_compare0 */
    case 381:  /* *andsi3_compare0 */
    case 198:  /* *subdi3_compare0 */
    case 197:  /* *subsi3_compare0 */
    case 68:  /* *adddi3_compare0 */
    case 67:  /* *addsi3_compare0 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 1741:  /* aarch64_cmgtdf */
    case 1740:  /* aarch64_cmgedf */
    case 1739:  /* aarch64_cmeqdf */
    case 1738:  /* aarch64_cmledf */
    case 1737:  /* aarch64_cmltdf */
    case 1736:  /* aarch64_cmgtsf */
    case 1735:  /* aarch64_cmgesf */
    case 1734:  /* aarch64_cmeqsf */
    case 1733:  /* aarch64_cmlesf */
    case 1732:  /* aarch64_cmltsf */
    case 1731:  /* aarch64_cmgtv2df */
    case 1730:  /* aarch64_cmgev2df */
    case 1729:  /* aarch64_cmeqv2df */
    case 1728:  /* aarch64_cmlev2df */
    case 1727:  /* aarch64_cmltv2df */
    case 1726:  /* aarch64_cmgtv4sf */
    case 1725:  /* aarch64_cmgev4sf */
    case 1724:  /* aarch64_cmeqv4sf */
    case 1723:  /* aarch64_cmlev4sf */
    case 1722:  /* aarch64_cmltv4sf */
    case 1721:  /* aarch64_cmgtv2sf */
    case 1720:  /* aarch64_cmgev2sf */
    case 1719:  /* aarch64_cmeqv2sf */
    case 1718:  /* aarch64_cmlev2sf */
    case 1717:  /* aarch64_cmltv2sf */
    case 1708:  /* aarch64_cmgtudi */
    case 1707:  /* aarch64_cmgeudi */
    case 1706:  /* aarch64_cmleudi */
    case 1705:  /* aarch64_cmltudi */
    case 1704:  /* aarch64_cmgtuv2di */
    case 1703:  /* aarch64_cmgeuv2di */
    case 1702:  /* aarch64_cmleuv2di */
    case 1701:  /* aarch64_cmltuv2di */
    case 1700:  /* aarch64_cmgtuv4si */
    case 1699:  /* aarch64_cmgeuv4si */
    case 1698:  /* aarch64_cmleuv4si */
    case 1697:  /* aarch64_cmltuv4si */
    case 1696:  /* aarch64_cmgtuv2si */
    case 1695:  /* aarch64_cmgeuv2si */
    case 1694:  /* aarch64_cmleuv2si */
    case 1693:  /* aarch64_cmltuv2si */
    case 1692:  /* aarch64_cmgtuv8hi */
    case 1691:  /* aarch64_cmgeuv8hi */
    case 1690:  /* aarch64_cmleuv8hi */
    case 1689:  /* aarch64_cmltuv8hi */
    case 1688:  /* aarch64_cmgtuv4hi */
    case 1687:  /* aarch64_cmgeuv4hi */
    case 1686:  /* aarch64_cmleuv4hi */
    case 1685:  /* aarch64_cmltuv4hi */
    case 1684:  /* aarch64_cmgtuv16qi */
    case 1683:  /* aarch64_cmgeuv16qi */
    case 1682:  /* aarch64_cmleuv16qi */
    case 1681:  /* aarch64_cmltuv16qi */
    case 1680:  /* aarch64_cmgtuv8qi */
    case 1679:  /* aarch64_cmgeuv8qi */
    case 1678:  /* aarch64_cmleuv8qi */
    case 1677:  /* aarch64_cmltuv8qi */
    case 1676:  /* aarch64_cmgtdi */
    case 1675:  /* aarch64_cmgedi */
    case 1674:  /* aarch64_cmeqdi */
    case 1673:  /* aarch64_cmledi */
    case 1672:  /* aarch64_cmltdi */
    case 1671:  /* aarch64_cmgtv2di */
    case 1670:  /* aarch64_cmgev2di */
    case 1669:  /* aarch64_cmeqv2di */
    case 1668:  /* aarch64_cmlev2di */
    case 1667:  /* aarch64_cmltv2di */
    case 1666:  /* aarch64_cmgtv4si */
    case 1665:  /* aarch64_cmgev4si */
    case 1664:  /* aarch64_cmeqv4si */
    case 1663:  /* aarch64_cmlev4si */
    case 1662:  /* aarch64_cmltv4si */
    case 1661:  /* aarch64_cmgtv2si */
    case 1660:  /* aarch64_cmgev2si */
    case 1659:  /* aarch64_cmeqv2si */
    case 1658:  /* aarch64_cmlev2si */
    case 1657:  /* aarch64_cmltv2si */
    case 1656:  /* aarch64_cmgtv8hi */
    case 1655:  /* aarch64_cmgev8hi */
    case 1654:  /* aarch64_cmeqv8hi */
    case 1653:  /* aarch64_cmlev8hi */
    case 1652:  /* aarch64_cmltv8hi */
    case 1651:  /* aarch64_cmgtv4hi */
    case 1650:  /* aarch64_cmgev4hi */
    case 1649:  /* aarch64_cmeqv4hi */
    case 1648:  /* aarch64_cmlev4hi */
    case 1647:  /* aarch64_cmltv4hi */
    case 1646:  /* aarch64_cmgtv16qi */
    case 1645:  /* aarch64_cmgev16qi */
    case 1644:  /* aarch64_cmeqv16qi */
    case 1643:  /* aarch64_cmlev16qi */
    case 1642:  /* aarch64_cmltv16qi */
    case 1641:  /* aarch64_cmgtv8qi */
    case 1640:  /* aarch64_cmgev8qi */
    case 1639:  /* aarch64_cmeqv8qi */
    case 1638:  /* aarch64_cmlev8qi */
    case 1637:  /* aarch64_cmltv8qi */
    case 914:  /* aarch64_simd_vec_unpacku_hi_v4si */
    case 913:  /* aarch64_simd_vec_unpacks_hi_v4si */
    case 912:  /* aarch64_simd_vec_unpacku_hi_v8hi */
    case 911:  /* aarch64_simd_vec_unpacks_hi_v8hi */
    case 910:  /* aarch64_simd_vec_unpacku_hi_v16qi */
    case 909:  /* aarch64_simd_vec_unpacks_hi_v16qi */
    case 908:  /* aarch64_simd_vec_unpacku_lo_v4si */
    case 907:  /* aarch64_simd_vec_unpacks_lo_v4si */
    case 906:  /* aarch64_simd_vec_unpacku_lo_v8hi */
    case 905:  /* aarch64_simd_vec_unpacks_lo_v8hi */
    case 904:  /* aarch64_simd_vec_unpacku_lo_v16qi */
    case 903:  /* aarch64_simd_vec_unpacks_lo_v16qi */
    case 768:  /* *fabd_scalardf3 */
    case 767:  /* *fabd_scalarsf3 */
    case 766:  /* fabdv2df_3 */
    case 765:  /* fabdv4sf_3 */
    case 764:  /* fabdv2sf_3 */
    case 757:  /* abdv4si_3 */
    case 756:  /* abdv2si_3 */
    case 755:  /* abdv8hi_3 */
    case 754:  /* abdv4hi_3 */
    case 753:  /* abdv16qi_3 */
    case 752:  /* abdv8qi_3 */
    case 529:  /* *extenddi_ashrhi */
    case 528:  /* *extenddi_ashrqi */
    case 527:  /* *extendsi_ashrhi */
    case 526:  /* *extendsi_ashrqi */
    case 525:  /* *zero_extenddi_lshrhi */
    case 524:  /* *zero_extenddi_lshrqi */
    case 523:  /* *zero_extendsi_lshrhi */
    case 522:  /* *zero_extendsi_lshrqi */
    case 521:  /* *zero_extenddi_ashlhi */
    case 520:  /* *extenddi_ashlhi */
    case 519:  /* *zero_extenddi_ashlqi */
    case 518:  /* *extenddi_ashlqi */
    case 517:  /* *zero_extendsi_ashlhi */
    case 516:  /* *extendsi_ashlhi */
    case 515:  /* *zero_extendsi_ashlqi */
    case 514:  /* *extendsi_ashlqi */
    case 513:  /* *rorsi3_insn_uxtw */
    case 499:  /* *rotrsi3_insn_uxtw */
    case 498:  /* *lshrsi3_insn_uxtw */
    case 497:  /* *ashrsi3_insn_uxtw */
    case 496:  /* *ashlsi3_insn_uxtw */
    case 441:  /* *one_cmpl_rotrdi2 */
    case 440:  /* *one_cmpl_lshrdi2 */
    case 439:  /* *one_cmpl_ashrdi2 */
    case 438:  /* *one_cmpl_ashldi2 */
    case 437:  /* *one_cmpl_rotrsi2 */
    case 436:  /* *one_cmpl_lshrsi2 */
    case 435:  /* *one_cmpl_ashrsi2 */
    case 434:  /* *one_cmpl_ashlsi2 */
    case 380:  /* *xorsi3_uxtw */
    case 379:  /* *iorsi3_uxtw */
    case 378:  /* *andsi3_uxtw */
    case 310:  /* *udivsi3_uxtw */
    case 309:  /* *divsi3_uxtw */
    case 285:  /* *mulsi3_uxtw */
    case 281:  /* *neg_mul_imm_di2 */
    case 280:  /* *neg_mul_imm_si2 */
    case 276:  /* *neg_lsr_di2 */
    case 275:  /* *neg_asr_di2 */
    case 274:  /* *neg_lsl_di2 */
    case 273:  /* *neg_lsr_si2 */
    case 272:  /* *neg_asr_si2 */
    case 271:  /* *neg_lsl_si2 */
    case 195:  /* *subsi3_uxtw */
    case 183:  /* *adddi3_carryin_alt1 */
    case 182:  /* *addsi3_carryin_alt1 */
    case 65:  /* *addsi3_aarch64_uxtw */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 1259:  /* aarch64_uqsubdi */
    case 1258:  /* aarch64_sqsubdi */
    case 1257:  /* aarch64_uqadddi */
    case 1256:  /* aarch64_sqadddi */
    case 1255:  /* aarch64_uqsubsi */
    case 1254:  /* aarch64_sqsubsi */
    case 1253:  /* aarch64_uqaddsi */
    case 1252:  /* aarch64_sqaddsi */
    case 1251:  /* aarch64_uqsubhi */
    case 1250:  /* aarch64_sqsubhi */
    case 1249:  /* aarch64_uqaddhi */
    case 1248:  /* aarch64_sqaddhi */
    case 1247:  /* aarch64_uqsubqi */
    case 1246:  /* aarch64_sqsubqi */
    case 1245:  /* aarch64_uqaddqi */
    case 1244:  /* aarch64_sqaddqi */
    case 1243:  /* aarch64_uqsubv2di */
    case 1242:  /* aarch64_sqsubv2di */
    case 1241:  /* aarch64_uqaddv2di */
    case 1240:  /* aarch64_sqaddv2di */
    case 1239:  /* aarch64_uqsubv4si */
    case 1238:  /* aarch64_sqsubv4si */
    case 1237:  /* aarch64_uqaddv4si */
    case 1236:  /* aarch64_sqaddv4si */
    case 1235:  /* aarch64_uqsubv2si */
    case 1234:  /* aarch64_sqsubv2si */
    case 1233:  /* aarch64_uqaddv2si */
    case 1232:  /* aarch64_sqaddv2si */
    case 1231:  /* aarch64_uqsubv8hi */
    case 1230:  /* aarch64_sqsubv8hi */
    case 1229:  /* aarch64_uqaddv8hi */
    case 1228:  /* aarch64_sqaddv8hi */
    case 1227:  /* aarch64_uqsubv4hi */
    case 1226:  /* aarch64_sqsubv4hi */
    case 1225:  /* aarch64_uqaddv4hi */
    case 1224:  /* aarch64_sqaddv4hi */
    case 1223:  /* aarch64_uqsubv16qi */
    case 1222:  /* aarch64_sqsubv16qi */
    case 1221:  /* aarch64_uqaddv16qi */
    case 1220:  /* aarch64_sqaddv16qi */
    case 1219:  /* aarch64_uqsubv8qi */
    case 1218:  /* aarch64_sqsubv8qi */
    case 1217:  /* aarch64_uqaddv8qi */
    case 1216:  /* aarch64_sqaddv8qi */
    case 1093:  /* aarch64_combinedf */
    case 1092:  /* aarch64_combinedi */
    case 1091:  /* aarch64_combinev2sf */
    case 1090:  /* aarch64_combinev2si */
    case 1089:  /* aarch64_combinev4hi */
    case 1088:  /* aarch64_combinev8qi */
    case 1087:  /* *aarch64_combinezv2si */
    case 1086:  /* *aarch64_combinezv4hi */
    case 1085:  /* *aarch64_combinezv8qi */
    case 1018:  /* sminv2df3 */
    case 1017:  /* sminv4sf3 */
    case 1016:  /* sminv2sf3 */
    case 1015:  /* smaxv2df3 */
    case 1014:  /* smaxv4sf3 */
    case 1013:  /* smaxv2sf3 */
    case 938:  /* divv2df3 */
    case 937:  /* divv4sf3 */
    case 936:  /* divv2sf3 */
    case 935:  /* mulv2df3 */
    case 934:  /* mulv4sf3 */
    case 933:  /* mulv2sf3 */
    case 932:  /* subv2df3 */
    case 931:  /* subv4sf3 */
    case 930:  /* subv2sf3 */
    case 929:  /* addv2df3 */
    case 928:  /* addv4sf3 */
    case 927:  /* addv2sf3 */
    case 884:  /* uminv4si3 */
    case 883:  /* umaxv4si3 */
    case 882:  /* sminv4si3 */
    case 881:  /* smaxv4si3 */
    case 880:  /* uminv2si3 */
    case 879:  /* umaxv2si3 */
    case 878:  /* sminv2si3 */
    case 877:  /* smaxv2si3 */
    case 876:  /* uminv8hi3 */
    case 875:  /* umaxv8hi3 */
    case 874:  /* sminv8hi3 */
    case 873:  /* smaxv8hi3 */
    case 872:  /* uminv4hi3 */
    case 871:  /* umaxv4hi3 */
    case 870:  /* sminv4hi3 */
    case 869:  /* smaxv4hi3 */
    case 868:  /* uminv16qi3 */
    case 867:  /* umaxv16qi3 */
    case 866:  /* sminv16qi3 */
    case 865:  /* smaxv16qi3 */
    case 864:  /* uminv8qi3 */
    case 863:  /* umaxv8qi3 */
    case 862:  /* sminv8qi3 */
    case 861:  /* smaxv8qi3 */
    case 830:  /* aarch64_simd_reg_sshlv2di */
    case 829:  /* aarch64_simd_reg_sshlv4si */
    case 828:  /* aarch64_simd_reg_sshlv2si */
    case 827:  /* aarch64_simd_reg_sshlv8hi */
    case 826:  /* aarch64_simd_reg_sshlv4hi */
    case 825:  /* aarch64_simd_reg_sshlv16qi */
    case 824:  /* aarch64_simd_reg_sshlv8qi */
    case 823:  /* aarch64_simd_imm_shlv2di */
    case 822:  /* aarch64_simd_imm_shlv4si */
    case 821:  /* aarch64_simd_imm_shlv2si */
    case 820:  /* aarch64_simd_imm_shlv8hi */
    case 819:  /* aarch64_simd_imm_shlv4hi */
    case 818:  /* aarch64_simd_imm_shlv16qi */
    case 817:  /* aarch64_simd_imm_shlv8qi */
    case 816:  /* aarch64_simd_ashrv2di */
    case 815:  /* aarch64_simd_ashrv4si */
    case 814:  /* aarch64_simd_ashrv2si */
    case 813:  /* aarch64_simd_ashrv8hi */
    case 812:  /* aarch64_simd_ashrv4hi */
    case 811:  /* aarch64_simd_ashrv16qi */
    case 810:  /* aarch64_simd_ashrv8qi */
    case 809:  /* aarch64_simd_lshrv2di */
    case 808:  /* aarch64_simd_lshrv4si */
    case 807:  /* aarch64_simd_lshrv2si */
    case 806:  /* aarch64_simd_lshrv8hi */
    case 805:  /* aarch64_simd_lshrv4hi */
    case 804:  /* aarch64_simd_lshrv16qi */
    case 803:  /* aarch64_simd_lshrv8qi */
    case 789:  /* xorv2di3 */
    case 788:  /* xorv4si3 */
    case 787:  /* xorv2si3 */
    case 786:  /* xorv8hi3 */
    case 785:  /* xorv4hi3 */
    case 784:  /* xorv16qi3 */
    case 783:  /* xorv8qi3 */
    case 782:  /* iorv2di3 */
    case 781:  /* iorv4si3 */
    case 780:  /* iorv2si3 */
    case 779:  /* iorv8hi3 */
    case 778:  /* iorv4hi3 */
    case 777:  /* iorv16qi3 */
    case 776:  /* iorv8qi3 */
    case 775:  /* andv2di3 */
    case 774:  /* andv4si3 */
    case 773:  /* andv2si3 */
    case 772:  /* andv8hi3 */
    case 771:  /* andv4hi3 */
    case 770:  /* andv16qi3 */
    case 769:  /* andv8qi3 */
    case 737:  /* mulv4si3 */
    case 736:  /* mulv2si3 */
    case 735:  /* mulv8hi3 */
    case 734:  /* mulv4hi3 */
    case 733:  /* mulv16qi3 */
    case 732:  /* mulv8qi3 */
    case 731:  /* subv2di3 */
    case 730:  /* subv4si3 */
    case 729:  /* subv2si3 */
    case 728:  /* subv8hi3 */
    case 727:  /* subv4hi3 */
    case 726:  /* subv16qi3 */
    case 725:  /* subv8qi3 */
    case 724:  /* addv2di3 */
    case 723:  /* addv4si3 */
    case 722:  /* addv2si3 */
    case 721:  /* addv8hi3 */
    case 720:  /* addv4hi3 */
    case 719:  /* addv16qi3 */
    case 718:  /* addv8qi3 */
    case 665:  /* add_losym */
    case 653:  /* smindf3 */
    case 652:  /* sminsf3 */
    case 651:  /* smaxdf3 */
    case 650:  /* smaxsf3 */
    case 643:  /* divdf3 */
    case 642:  /* divsf3 */
    case 639:  /* muldf3 */
    case 638:  /* mulsf3 */
    case 637:  /* subdf3 */
    case 636:  /* subsf3 */
    case 635:  /* adddf3 */
    case 634:  /* addsf3 */
    case 512:  /* *rordi3_insn */
    case 511:  /* *rorsi3_insn */
    case 507:  /* *lshrhi3_insn */
    case 506:  /* *ashrhi3_insn */
    case 505:  /* *ashlhi3_insn */
    case 504:  /* *lshrqi3_insn */
    case 503:  /* *ashrqi3_insn */
    case 502:  /* *ashlqi3_insn */
    case 501:  /* *ashlhi3_insn */
    case 500:  /* *ashlqi3_insn */
    case 495:  /* *rotrdi3_insn */
    case 494:  /* *lshrdi3_insn */
    case 493:  /* *ashrdi3_insn */
    case 492:  /* *ashldi3_insn */
    case 491:  /* *rotrsi3_insn */
    case 490:  /* *lshrsi3_insn */
    case 489:  /* *ashrsi3_insn */
    case 488:  /* *ashlsi3_insn */
    case 377:  /* xordi3 */
    case 376:  /* iordi3 */
    case 375:  /* anddi3 */
    case 374:  /* xorsi3 */
    case 373:  /* iorsi3 */
    case 372:  /* andsi3 */
    case 308:  /* udivdi3 */
    case 307:  /* divdi3 */
    case 306:  /* udivsi3 */
    case 305:  /* divsi3 */
    case 284:  /* muldi3 */
    case 283:  /* mulsi3 */
    case 196:  /* subdi3 */
    case 194:  /* subsi3 */
    case 66:  /* *adddi3_aarch64 */
    case 64:  /* *addsi3_aarch64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1924:  /* *aarch64_simd_ld1rdi */
    case 1923:  /* *aarch64_simd_ld1rv2df */
    case 1922:  /* *aarch64_simd_ld1rv4sf */
    case 1921:  /* *aarch64_simd_ld1rv2sf */
    case 1920:  /* *aarch64_simd_ld1rv2di */
    case 1919:  /* *aarch64_simd_ld1rv4si */
    case 1918:  /* *aarch64_simd_ld1rv2si */
    case 1917:  /* *aarch64_simd_ld1rv8hi */
    case 1916:  /* *aarch64_simd_ld1rv4hi */
    case 1915:  /* *aarch64_simd_ld1rv16qi */
    case 1914:  /* *aarch64_simd_ld1rv8qi */
    case 1774:  /* sqrtv2df2 */
    case 1773:  /* sqrtv4sf2 */
    case 1772:  /* sqrtv2sf2 */
    case 1319:  /* aarch64_sqabssi */
    case 1318:  /* aarch64_sqnegsi */
    case 1317:  /* aarch64_sqabshi */
    case 1316:  /* aarch64_sqneghi */
    case 1315:  /* aarch64_sqabsqi */
    case 1314:  /* aarch64_sqnegqi */
    case 1313:  /* aarch64_sqabsv2di */
    case 1312:  /* aarch64_sqnegv2di */
    case 1311:  /* aarch64_sqabsv4si */
    case 1310:  /* aarch64_sqnegv4si */
    case 1309:  /* aarch64_sqabsv2si */
    case 1308:  /* aarch64_sqnegv2si */
    case 1307:  /* aarch64_sqabsv8hi */
    case 1306:  /* aarch64_sqnegv8hi */
    case 1305:  /* aarch64_sqabsv4hi */
    case 1304:  /* aarch64_sqnegv4hi */
    case 1303:  /* aarch64_sqabsv16qi */
    case 1302:  /* aarch64_sqnegv16qi */
    case 1301:  /* aarch64_sqabsv8qi */
    case 1300:  /* aarch64_sqnegv8qi */
    case 1008:  /* aarch64_float_truncate_lo_v2sf */
    case 1006:  /* aarch64_float_extend_lo_v2df */
    case 1004:  /* floatunsv2div2df2 */
    case 1003:  /* floatv2div2df2 */
    case 1002:  /* floatunsv4siv4sf2 */
    case 1001:  /* floatv4siv4sf2 */
    case 1000:  /* floatunsv2siv2sf2 */
    case 999:  /* floatv2siv2sf2 */
    case 944:  /* absv2df2 */
    case 943:  /* absv4sf2 */
    case 942:  /* absv2sf2 */
    case 941:  /* negv2df2 */
    case 940:  /* negv4sf2 */
    case 939:  /* negv2sf2 */
    case 899:  /* aarch64_simd_vec_pack_trunc_v2di */
    case 898:  /* aarch64_simd_vec_pack_trunc_v4si */
    case 897:  /* aarch64_simd_vec_pack_trunc_v8hi */
    case 890:  /* move_lo_quad_v2df */
    case 889:  /* move_lo_quad_v4sf */
    case 888:  /* move_lo_quad_v2di */
    case 887:  /* move_lo_quad_v4si */
    case 886:  /* move_lo_quad_v8hi */
    case 885:  /* move_lo_quad_v16qi */
    case 796:  /* one_cmplv2di2 */
    case 795:  /* one_cmplv4si2 */
    case 794:  /* one_cmplv2si2 */
    case 793:  /* one_cmplv8hi2 */
    case 792:  /* one_cmplv4hi2 */
    case 791:  /* one_cmplv16qi2 */
    case 790:  /* one_cmplv8qi2 */
    case 751:  /* absv2di2 */
    case 750:  /* absv4si2 */
    case 749:  /* absv2si2 */
    case 748:  /* absv8hi2 */
    case 747:  /* absv4hi2 */
    case 746:  /* absv16qi2 */
    case 745:  /* absv8qi2 */
    case 744:  /* negv2di2 */
    case 743:  /* negv4si2 */
    case 742:  /* negv2si2 */
    case 741:  /* negv8hi2 */
    case 740:  /* negv4hi2 */
    case 739:  /* negv16qi2 */
    case 738:  /* negv8qi2 */
    case 693:  /* aarch64_simd_dupv2df */
    case 692:  /* aarch64_simd_dupv4sf */
    case 691:  /* aarch64_simd_dupv2sf */
    case 679:  /* aarch64_simd_dupv2di */
    case 678:  /* aarch64_simd_dupv4si */
    case 677:  /* aarch64_simd_dupv2si */
    case 676:  /* aarch64_simd_dupv8hi */
    case 675:  /* aarch64_simd_dupv4hi */
    case 674:  /* aarch64_simd_dupv16qi */
    case 673:  /* aarch64_simd_dupv8qi */
    case 663:  /* aarch64_movtilow_di */
    case 660:  /* aarch64_movdi_tilow */
    case 649:  /* absdf2 */
    case 648:  /* abssf2 */
    case 647:  /* sqrtdf2 */
    case 646:  /* sqrtsf2 */
    case 645:  /* negdf2 */
    case 644:  /* negsf2 */
    case 633:  /* floatunsdidf2 */
    case 632:  /* floatunssidf2 */
    case 631:  /* floatunsdisf2 */
    case 630:  /* floatunssisf2 */
    case 629:  /* floatdidf2 */
    case 628:  /* floatsidf2 */
    case 627:  /* floatdisf2 */
    case 626:  /* floatsisf2 */
    case 625:  /* fixuns_truncdfdi2 */
    case 624:  /* fixuns_truncdfsi2 */
    case 623:  /* fixuns_truncsfdi2 */
    case 622:  /* fixuns_truncsfsi2 */
    case 621:  /* fix_truncdfdi2 */
    case 620:  /* fix_truncdfsi2 */
    case 619:  /* fix_truncsfdi2 */
    case 618:  /* fix_truncsfsi2 */
    case 617:  /* truncdfsf2 */
    case 616:  /* extendsfdf2 */
    case 550:  /* bswaphi2 */
    case 549:  /* bswapdi2 */
    case 548:  /* bswapsi2 */
    case 473:  /* clzdi2 */
    case 472:  /* clzsi2 */
    case 433:  /* one_cmpldi2 */
    case 432:  /* one_cmplsi2 */
    case 257:  /* negdi2 */
    case 256:  /* negsi2 */
    case 63:  /* *zero_extendqihi2_aarch64 */
    case 62:  /* *extendqihi2_aarch64 */
    case 61:  /* *zero_extendhidi2_aarch64 */
    case 60:  /* *zero_extendqidi2_aarch64 */
    case 59:  /* *zero_extendhisi2_aarch64 */
    case 58:  /* *zero_extendqisi2_aarch64 */
    case 57:  /* *extendhidi2_aarch64 */
    case 56:  /* *extendqidi2_aarch64 */
    case 55:  /* *extendhisi2_aarch64 */
    case 54:  /* *extendqisi2_aarch64 */
    case 53:  /* *zero_extendsidi2_aarch64 */
    case 52:  /* *extendsidi2_aarch64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 51:  /* storewb_pairdi_di */
    case 50:  /* storewb_pairsi_di */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 0), 0), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0), 0);
      recog_data.dup_num[1] = 0;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0), 1);
      recog_data.dup_num[2] = 4;
      break;

    case 49:  /* loadwb_pairdi_di */
    case 48:  /* loadwb_pairsi_di */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[2] = 4;
      break;

    case 47:  /* store_pairdf */
    case 46:  /* store_pairsf */
    case 45:  /* load_pairdf */
    case 44:  /* load_pairsf */
    case 43:  /* store_pairdi */
    case 42:  /* store_pairsi */
    case 41:  /* load_pairdi */
    case 40:  /* load_pairsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 35:  /* insv_immdi */
    case 34:  /* insv_immsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 1813:  /* *aarch64_movxi */
    case 1812:  /* *aarch64_movci */
    case 1811:  /* *aarch64_movoi */
    case 703:  /* *aarch64_simd_movv2df */
    case 702:  /* *aarch64_simd_movv4sf */
    case 701:  /* *aarch64_simd_movv2di */
    case 700:  /* *aarch64_simd_movv4si */
    case 699:  /* *aarch64_simd_movv8hi */
    case 698:  /* *aarch64_simd_movv16qi */
    case 697:  /* *aarch64_simd_movv2sf */
    case 696:  /* *aarch64_simd_movv2si */
    case 695:  /* *aarch64_simd_movv4hi */
    case 694:  /* *aarch64_simd_movv8qi */
    case 39:  /* *movtf_aarch64 */
    case 38:  /* *movdf_aarch64 */
    case 37:  /* *movsf_aarch64 */
    case 36:  /* *movti_aarch64 */
    case 33:  /* *movdi_aarch64 */
    case 32:  /* *movsi_aarch64 */
    case 31:  /* *movhi_aarch64 */
    case 30:  /* *movqi_aarch64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 29:  /* *sibcall_value_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 28:  /* *sibcall_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 27:  /* *call_value_symbol */
    case 26:  /* *call_value_reg */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 25:  /* *call_symbol */
    case 24:  /* *call_reg */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 23:  /* *cbgedi1 */
    case 22:  /* *cbltdi1 */
    case 21:  /* *cbgesi1 */
    case 20:  /* *cbltsi1 */
    case 19:  /* *cbgehi1 */
    case 18:  /* *cblthi1 */
    case 17:  /* *cbgeqi1 */
    case 16:  /* *cbltqi1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 15:  /* *tbnedi1 */
    case 14:  /* *tbeqdi1 */
    case 13:  /* *tbnesi1 */
    case 12:  /* *tbeqsi1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 11:  /* *cbnedi1 */
    case 10:  /* *cbeqdi1 */
    case 9:  /* *cbnesi1 */
    case 8:  /* *cbeqsi1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 7:  /* eh_return */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 6:  /* *do_return */
    case 5:  /* nop */
      break;

    case 4:  /* casesi_dispatch */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 4), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      break;

    case 3:  /* *condjump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 2:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 1:  /* indirect_jump */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    }
}
