/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expr.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x010a0b, CODE_FOR_extendqihi2 },
  { 0x010a0c, CODE_FOR_extendqisi2 },
  { 0x010a0d, CODE_FOR_extendqidi2 },
  { 0x010b0c, CODE_FOR_extendhisi2 },
  { 0x010b0d, CODE_FOR_extendhidi2 },
  { 0x010c0d, CODE_FOR_extendsidi2 },
  { 0x012526, CODE_FOR_extendsfdf2 },
  { 0x022625, CODE_FOR_truncdfsf2 },
  { 0x030a0b, CODE_FOR_zero_extendqihi2 },
  { 0x030a0c, CODE_FOR_zero_extendqisi2 },
  { 0x030a0d, CODE_FOR_zero_extendqidi2 },
  { 0x030b0c, CODE_FOR_zero_extendhisi2 },
  { 0x030b0d, CODE_FOR_zero_extendhidi2 },
  { 0x030c0d, CODE_FOR_zero_extendsidi2 },
  { 0x044f39, CODE_FOR_fixv2sfv2si2 },
  { 0x04503c, CODE_FOR_fixv4sfv4si2 },
  { 0x04513d, CODE_FOR_fixv2dfv2di2 },
  { 0x054f39, CODE_FOR_fixunsv2sfv2si2 },
  { 0x05503c, CODE_FOR_fixunsv4sfv4si2 },
  { 0x05513d, CODE_FOR_fixunsv2dfv2di2 },
  { 0x060c25, CODE_FOR_floatsisf2 },
  { 0x060c26, CODE_FOR_floatsidf2 },
  { 0x060d25, CODE_FOR_floatdisf2 },
  { 0x060d26, CODE_FOR_floatdidf2 },
  { 0x06394f, CODE_FOR_floatv2siv2sf2 },
  { 0x063c50, CODE_FOR_floatv4siv4sf2 },
  { 0x063d51, CODE_FOR_floatv2div2df2 },
  { 0x070c25, CODE_FOR_floatunssisf2 },
  { 0x070c26, CODE_FOR_floatunssidf2 },
  { 0x070d25, CODE_FOR_floatunsdisf2 },
  { 0x070d26, CODE_FOR_floatunsdidf2 },
  { 0x07394f, CODE_FOR_floatunsv2siv2sf2 },
  { 0x073c50, CODE_FOR_floatunsv4siv4sf2 },
  { 0x073d51, CODE_FOR_floatunsv2div2df2 },
  { 0x09250c, CODE_FOR_lroundsfsi2 },
  { 0x09250d, CODE_FOR_lroundsfdi2 },
  { 0x09260c, CODE_FOR_lrounddfsi2 },
  { 0x09260d, CODE_FOR_lrounddfdi2 },
  { 0x094f39, CODE_FOR_lroundv2sfv2si2 },
  { 0x09503c, CODE_FOR_lroundv4sfv4si2 },
  { 0x09513d, CODE_FOR_lroundv2dfv2di2 },
  { 0x0a250c, CODE_FOR_lfloorsfsi2 },
  { 0x0a250d, CODE_FOR_lfloorsfdi2 },
  { 0x0a260c, CODE_FOR_lfloordfsi2 },
  { 0x0a260d, CODE_FOR_lfloordfdi2 },
  { 0x0a4f39, CODE_FOR_lfloorv2sfv2si2 },
  { 0x0a503c, CODE_FOR_lfloorv4sfv4si2 },
  { 0x0a513d, CODE_FOR_lfloorv2dfv2di2 },
  { 0x0b250c, CODE_FOR_lceilsfsi2 },
  { 0x0b250d, CODE_FOR_lceilsfdi2 },
  { 0x0b260c, CODE_FOR_lceildfsi2 },
  { 0x0b260d, CODE_FOR_lceildfdi2 },
  { 0x0b4f39, CODE_FOR_lceilv2sfv2si2 },
  { 0x0b503c, CODE_FOR_lceilv4sfv4si2 },
  { 0x0b513d, CODE_FOR_lceilv2dfv2di2 },
  { 0x10250c, CODE_FOR_fix_truncsfsi2 },
  { 0x10250d, CODE_FOR_fix_truncsfdi2 },
  { 0x10260c, CODE_FOR_fix_truncdfsi2 },
  { 0x10260d, CODE_FOR_fix_truncdfdi2 },
  { 0x104f39, CODE_FOR_fix_truncv2sfv2si2 },
  { 0x10503c, CODE_FOR_fix_truncv4sfv4si2 },
  { 0x10513d, CODE_FOR_fix_truncv2dfv2di2 },
  { 0x11250c, CODE_FOR_fixuns_truncsfsi2 },
  { 0x11250d, CODE_FOR_fixuns_truncsfdi2 },
  { 0x11260c, CODE_FOR_fixuns_truncdfsi2 },
  { 0x11260d, CODE_FOR_fixuns_truncdfdi2 },
  { 0x114f39, CODE_FOR_fixuns_truncv2sfv2si2 },
  { 0x11503c, CODE_FOR_fixuns_truncv4sfv4si2 },
  { 0x11513d, CODE_FOR_fixuns_truncv2dfv2di2 },
  { 0x120c0d, CODE_FOR_mulsidi3 },
  { 0x130c0d, CODE_FOR_umulsidi3 },
  { 0x150c0d, CODE_FOR_maddsidi4 },
  { 0x160c0d, CODE_FOR_umaddsidi4 },
  { 0x190c0d, CODE_FOR_msubsidi4 },
  { 0x1a0c0d, CODE_FOR_umsubsidi4 },
  { 0x1d3a10, CODE_FOR_vec_load_lanesoiv16qi },
  { 0x1d3a11, CODE_FOR_vec_load_lanesciv16qi },
  { 0x1d3a12, CODE_FOR_vec_load_lanesxiv16qi },
  { 0x1d3b10, CODE_FOR_vec_load_lanesoiv8hi },
  { 0x1d3b11, CODE_FOR_vec_load_lanesciv8hi },
  { 0x1d3b12, CODE_FOR_vec_load_lanesxiv8hi },
  { 0x1d3c10, CODE_FOR_vec_load_lanesoiv4si },
  { 0x1d3c11, CODE_FOR_vec_load_lanesciv4si },
  { 0x1d3c12, CODE_FOR_vec_load_lanesxiv4si },
  { 0x1d3d10, CODE_FOR_vec_load_lanesoiv2di },
  { 0x1d3d11, CODE_FOR_vec_load_lanesciv2di },
  { 0x1d3d12, CODE_FOR_vec_load_lanesxiv2di },
  { 0x1d5010, CODE_FOR_vec_load_lanesoiv4sf },
  { 0x1d5011, CODE_FOR_vec_load_lanesciv4sf },
  { 0x1d5012, CODE_FOR_vec_load_lanesxiv4sf },
  { 0x1d5110, CODE_FOR_vec_load_lanesoiv2df },
  { 0x1d5111, CODE_FOR_vec_load_lanesciv2df },
  { 0x1d5112, CODE_FOR_vec_load_lanesxiv2df },
  { 0x1e3a10, CODE_FOR_vec_store_lanesoiv16qi },
  { 0x1e3a11, CODE_FOR_vec_store_lanesciv16qi },
  { 0x1e3a12, CODE_FOR_vec_store_lanesxiv16qi },
  { 0x1e3b10, CODE_FOR_vec_store_lanesoiv8hi },
  { 0x1e3b11, CODE_FOR_vec_store_lanesciv8hi },
  { 0x1e3b12, CODE_FOR_vec_store_lanesxiv8hi },
  { 0x1e3c10, CODE_FOR_vec_store_lanesoiv4si },
  { 0x1e3c11, CODE_FOR_vec_store_lanesciv4si },
  { 0x1e3c12, CODE_FOR_vec_store_lanesxiv4si },
  { 0x1e3d10, CODE_FOR_vec_store_lanesoiv2di },
  { 0x1e3d11, CODE_FOR_vec_store_lanesciv2di },
  { 0x1e3d12, CODE_FOR_vec_store_lanesxiv2di },
  { 0x1e5010, CODE_FOR_vec_store_lanesoiv4sf },
  { 0x1e5011, CODE_FOR_vec_store_lanesciv4sf },
  { 0x1e5012, CODE_FOR_vec_store_lanesxiv4sf },
  { 0x1e5110, CODE_FOR_vec_store_lanesoiv2df },
  { 0x1e5111, CODE_FOR_vec_store_lanesciv2df },
  { 0x1e5112, CODE_FOR_vec_store_lanesxiv2df },
  { 0x1f3737, CODE_FOR_vcondv8qiv8qi },
  { 0x1f3838, CODE_FOR_vcondv4hiv4hi },
  { 0x1f3939, CODE_FOR_vcondv2siv2si },
  { 0x1f3a3a, CODE_FOR_vcondv16qiv16qi },
  { 0x1f3b3b, CODE_FOR_vcondv8hiv8hi },
  { 0x1f3c3c, CODE_FOR_vcondv4siv4si },
  { 0x1f3d3d, CODE_FOR_vcondv2div2di },
  { 0x1f4f39, CODE_FOR_vcondv2siv2sf },
  { 0x1f4f4f, CODE_FOR_vcondv2sfv2sf },
  { 0x1f503c, CODE_FOR_vcondv4siv4sf },
  { 0x1f5050, CODE_FOR_vcondv4sfv4sf },
  { 0x1f513d, CODE_FOR_vcondv2div2df },
  { 0x1f5151, CODE_FOR_vcondv2dfv2df },
  { 0x203737, CODE_FOR_vconduv8qiv8qi },
  { 0x203838, CODE_FOR_vconduv4hiv4hi },
  { 0x203939, CODE_FOR_vconduv2siv2si },
  { 0x203a3a, CODE_FOR_vconduv16qiv16qi },
  { 0x203b3b, CODE_FOR_vconduv8hiv8hi },
  { 0x203c3c, CODE_FOR_vconduv4siv4si },
  { 0x203d3d, CODE_FOR_vconduv2div2di },
  { 0x21000c, CODE_FOR_addsi3 },
  { 0x21000d, CODE_FOR_adddi3 },
  { 0x210025, CODE_FOR_addsf3 },
  { 0x210026, CODE_FOR_adddf3 },
  { 0x210037, CODE_FOR_addv8qi3 },
  { 0x210038, CODE_FOR_addv4hi3 },
  { 0x210039, CODE_FOR_addv2si3 },
  { 0x21003a, CODE_FOR_addv16qi3 },
  { 0x21003b, CODE_FOR_addv8hi3 },
  { 0x21003c, CODE_FOR_addv4si3 },
  { 0x21003d, CODE_FOR_addv2di3 },
  { 0x21004f, CODE_FOR_addv2sf3 },
  { 0x210050, CODE_FOR_addv4sf3 },
  { 0x210051, CODE_FOR_addv2df3 },
  { 0x25000c, CODE_FOR_subsi3 },
  { 0x25000d, CODE_FOR_subdi3 },
  { 0x250025, CODE_FOR_subsf3 },
  { 0x250026, CODE_FOR_subdf3 },
  { 0x250037, CODE_FOR_subv8qi3 },
  { 0x250038, CODE_FOR_subv4hi3 },
  { 0x250039, CODE_FOR_subv2si3 },
  { 0x25003a, CODE_FOR_subv16qi3 },
  { 0x25003b, CODE_FOR_subv8hi3 },
  { 0x25003c, CODE_FOR_subv4si3 },
  { 0x25003d, CODE_FOR_subv2di3 },
  { 0x25004f, CODE_FOR_subv2sf3 },
  { 0x250050, CODE_FOR_subv4sf3 },
  { 0x250051, CODE_FOR_subv2df3 },
  { 0x29000c, CODE_FOR_mulsi3 },
  { 0x29000d, CODE_FOR_muldi3 },
  { 0x290025, CODE_FOR_mulsf3 },
  { 0x290026, CODE_FOR_muldf3 },
  { 0x290037, CODE_FOR_mulv8qi3 },
  { 0x290038, CODE_FOR_mulv4hi3 },
  { 0x290039, CODE_FOR_mulv2si3 },
  { 0x29003a, CODE_FOR_mulv16qi3 },
  { 0x29003b, CODE_FOR_mulv8hi3 },
  { 0x29003c, CODE_FOR_mulv4si3 },
  { 0x29004f, CODE_FOR_mulv2sf3 },
  { 0x290050, CODE_FOR_mulv4sf3 },
  { 0x290051, CODE_FOR_mulv2df3 },
  { 0x2d000c, CODE_FOR_divsi3 },
  { 0x2d000d, CODE_FOR_divdi3 },
  { 0x2d0025, CODE_FOR_divsf3 },
  { 0x2d0026, CODE_FOR_divdf3 },
  { 0x2d004f, CODE_FOR_divv2sf3 },
  { 0x2d0050, CODE_FOR_divv4sf3 },
  { 0x2d0051, CODE_FOR_divv2df3 },
  { 0x30000c, CODE_FOR_udivsi3 },
  { 0x30000d, CODE_FOR_udivdi3 },
  { 0x36004f, CODE_FOR_ftruncv2sf2 },
  { 0x360050, CODE_FOR_ftruncv4sf2 },
  { 0x360051, CODE_FOR_ftruncv2df2 },
  { 0x37000c, CODE_FOR_andsi3 },
  { 0x37000d, CODE_FOR_anddi3 },
  { 0x370037, CODE_FOR_andv8qi3 },
  { 0x370038, CODE_FOR_andv4hi3 },
  { 0x370039, CODE_FOR_andv2si3 },
  { 0x37003a, CODE_FOR_andv16qi3 },
  { 0x37003b, CODE_FOR_andv8hi3 },
  { 0x37003c, CODE_FOR_andv4si3 },
  { 0x37003d, CODE_FOR_andv2di3 },
  { 0x38000c, CODE_FOR_iorsi3 },
  { 0x38000d, CODE_FOR_iordi3 },
  { 0x380037, CODE_FOR_iorv8qi3 },
  { 0x380038, CODE_FOR_iorv4hi3 },
  { 0x380039, CODE_FOR_iorv2si3 },
  { 0x38003a, CODE_FOR_iorv16qi3 },
  { 0x38003b, CODE_FOR_iorv8hi3 },
  { 0x38003c, CODE_FOR_iorv4si3 },
  { 0x38003d, CODE_FOR_iorv2di3 },
  { 0x39000c, CODE_FOR_xorsi3 },
  { 0x39000d, CODE_FOR_xordi3 },
  { 0x390037, CODE_FOR_xorv8qi3 },
  { 0x390038, CODE_FOR_xorv4hi3 },
  { 0x390039, CODE_FOR_xorv2si3 },
  { 0x39003a, CODE_FOR_xorv16qi3 },
  { 0x39003b, CODE_FOR_xorv8hi3 },
  { 0x39003c, CODE_FOR_xorv4si3 },
  { 0x39003d, CODE_FOR_xorv2di3 },
  { 0x3a000a, CODE_FOR_ashlqi3 },
  { 0x3a000b, CODE_FOR_ashlhi3 },
  { 0x3a000c, CODE_FOR_ashlsi3 },
  { 0x3a000d, CODE_FOR_ashldi3 },
  { 0x3a0037, CODE_FOR_ashlv8qi3 },
  { 0x3a0038, CODE_FOR_ashlv4hi3 },
  { 0x3a0039, CODE_FOR_ashlv2si3 },
  { 0x3a003a, CODE_FOR_ashlv16qi3 },
  { 0x3a003b, CODE_FOR_ashlv8hi3 },
  { 0x3a003c, CODE_FOR_ashlv4si3 },
  { 0x3a003d, CODE_FOR_ashlv2di3 },
  { 0x3d000c, CODE_FOR_ashrsi3 },
  { 0x3d000d, CODE_FOR_ashrdi3 },
  { 0x3d0037, CODE_FOR_ashrv8qi3 },
  { 0x3d0038, CODE_FOR_ashrv4hi3 },
  { 0x3d0039, CODE_FOR_ashrv2si3 },
  { 0x3d003a, CODE_FOR_ashrv16qi3 },
  { 0x3d003b, CODE_FOR_ashrv8hi3 },
  { 0x3d003c, CODE_FOR_ashrv4si3 },
  { 0x3d003d, CODE_FOR_ashrv2di3 },
  { 0x3e000c, CODE_FOR_lshrsi3 },
  { 0x3e000d, CODE_FOR_lshrdi3 },
  { 0x3e0037, CODE_FOR_lshrv8qi3 },
  { 0x3e0038, CODE_FOR_lshrv4hi3 },
  { 0x3e0039, CODE_FOR_lshrv2si3 },
  { 0x3e003a, CODE_FOR_lshrv16qi3 },
  { 0x3e003b, CODE_FOR_lshrv8hi3 },
  { 0x3e003c, CODE_FOR_lshrv4si3 },
  { 0x3e003d, CODE_FOR_lshrv2di3 },
  { 0x3f000c, CODE_FOR_rotlsi3 },
  { 0x3f000d, CODE_FOR_rotldi3 },
  { 0x40000c, CODE_FOR_rotrsi3 },
  { 0x40000d, CODE_FOR_rotrdi3 },
  { 0x410037, CODE_FOR_vashlv8qi3 },
  { 0x410038, CODE_FOR_vashlv4hi3 },
  { 0x410039, CODE_FOR_vashlv2si3 },
  { 0x41003a, CODE_FOR_vashlv16qi3 },
  { 0x41003b, CODE_FOR_vashlv8hi3 },
  { 0x41003c, CODE_FOR_vashlv4si3 },
  { 0x41003d, CODE_FOR_vashlv2di3 },
  { 0x420037, CODE_FOR_vashrv8qi3 },
  { 0x420038, CODE_FOR_vashrv4hi3 },
  { 0x420039, CODE_FOR_vashrv2si3 },
  { 0x42003a, CODE_FOR_vashrv16qi3 },
  { 0x42003b, CODE_FOR_vashrv8hi3 },
  { 0x42003c, CODE_FOR_vashrv4si3 },
  { 0x430037, CODE_FOR_vlshrv8qi3 },
  { 0x430038, CODE_FOR_vlshrv4hi3 },
  { 0x430039, CODE_FOR_vlshrv2si3 },
  { 0x43003a, CODE_FOR_vlshrv16qi3 },
  { 0x43003b, CODE_FOR_vlshrv8hi3 },
  { 0x43003c, CODE_FOR_vlshrv4si3 },
  { 0x460025, CODE_FOR_sminsf3 },
  { 0x460026, CODE_FOR_smindf3 },
  { 0x460037, CODE_FOR_sminv8qi3 },
  { 0x460038, CODE_FOR_sminv4hi3 },
  { 0x460039, CODE_FOR_sminv2si3 },
  { 0x46003a, CODE_FOR_sminv16qi3 },
  { 0x46003b, CODE_FOR_sminv8hi3 },
  { 0x46003c, CODE_FOR_sminv4si3 },
  { 0x46004f, CODE_FOR_sminv2sf3 },
  { 0x460050, CODE_FOR_sminv4sf3 },
  { 0x460051, CODE_FOR_sminv2df3 },
  { 0x470025, CODE_FOR_smaxsf3 },
  { 0x470026, CODE_FOR_smaxdf3 },
  { 0x470037, CODE_FOR_smaxv8qi3 },
  { 0x470038, CODE_FOR_smaxv4hi3 },
  { 0x470039, CODE_FOR_smaxv2si3 },
  { 0x47003a, CODE_FOR_smaxv16qi3 },
  { 0x47003b, CODE_FOR_smaxv8hi3 },
  { 0x47003c, CODE_FOR_smaxv4si3 },
  { 0x47004f, CODE_FOR_smaxv2sf3 },
  { 0x470050, CODE_FOR_smaxv4sf3 },
  { 0x470051, CODE_FOR_smaxv2df3 },
  { 0x480037, CODE_FOR_uminv8qi3 },
  { 0x480038, CODE_FOR_uminv4hi3 },
  { 0x480039, CODE_FOR_uminv2si3 },
  { 0x48003a, CODE_FOR_uminv16qi3 },
  { 0x48003b, CODE_FOR_uminv8hi3 },
  { 0x48003c, CODE_FOR_uminv4si3 },
  { 0x490037, CODE_FOR_umaxv8qi3 },
  { 0x490038, CODE_FOR_umaxv4hi3 },
  { 0x490039, CODE_FOR_umaxv2si3 },
  { 0x49003a, CODE_FOR_umaxv16qi3 },
  { 0x49003b, CODE_FOR_umaxv8hi3 },
  { 0x49003c, CODE_FOR_umaxv4si3 },
  { 0x4a000c, CODE_FOR_negsi2 },
  { 0x4a000d, CODE_FOR_negdi2 },
  { 0x4a0025, CODE_FOR_negsf2 },
  { 0x4a0026, CODE_FOR_negdf2 },
  { 0x4a0037, CODE_FOR_negv8qi2 },
  { 0x4a0038, CODE_FOR_negv4hi2 },
  { 0x4a0039, CODE_FOR_negv2si2 },
  { 0x4a003a, CODE_FOR_negv16qi2 },
  { 0x4a003b, CODE_FOR_negv8hi2 },
  { 0x4a003c, CODE_FOR_negv4si2 },
  { 0x4a003d, CODE_FOR_negv2di2 },
  { 0x4a004f, CODE_FOR_negv2sf2 },
  { 0x4a0050, CODE_FOR_negv4sf2 },
  { 0x4a0051, CODE_FOR_negv2df2 },
  { 0x4e0025, CODE_FOR_abssf2 },
  { 0x4e0026, CODE_FOR_absdf2 },
  { 0x4e0037, CODE_FOR_absv8qi2 },
  { 0x4e0038, CODE_FOR_absv4hi2 },
  { 0x4e0039, CODE_FOR_absv2si2 },
  { 0x4e003a, CODE_FOR_absv16qi2 },
  { 0x4e003b, CODE_FOR_absv8hi2 },
  { 0x4e003c, CODE_FOR_absv4si2 },
  { 0x4e003d, CODE_FOR_absv2di2 },
  { 0x4e004f, CODE_FOR_absv2sf2 },
  { 0x4e0050, CODE_FOR_absv4sf2 },
  { 0x4e0051, CODE_FOR_absv2df2 },
  { 0x50000c, CODE_FOR_one_cmplsi2 },
  { 0x50000d, CODE_FOR_one_cmpldi2 },
  { 0x500037, CODE_FOR_one_cmplv8qi2 },
  { 0x500038, CODE_FOR_one_cmplv4hi2 },
  { 0x500039, CODE_FOR_one_cmplv2si2 },
  { 0x50003a, CODE_FOR_one_cmplv16qi2 },
  { 0x50003b, CODE_FOR_one_cmplv8hi2 },
  { 0x50003c, CODE_FOR_one_cmplv4si2 },
  { 0x50003d, CODE_FOR_one_cmplv2di2 },
  { 0x51000b, CODE_FOR_bswaphi2 },
  { 0x51000c, CODE_FOR_bswapsi2 },
  { 0x51000d, CODE_FOR_bswapdi2 },
  { 0x52000c, CODE_FOR_ffssi2 },
  { 0x52000d, CODE_FOR_ffsdi2 },
  { 0x53000c, CODE_FOR_clzsi2 },
  { 0x53000d, CODE_FOR_clzdi2 },
  { 0x54000c, CODE_FOR_ctzsi2 },
  { 0x54000d, CODE_FOR_ctzdi2 },
  { 0x55000c, CODE_FOR_clrsbsi2 },
  { 0x55000d, CODE_FOR_clrsbdi2 },
  { 0x620025, CODE_FOR_sqrtsf2 },
  { 0x620026, CODE_FOR_sqrtdf2 },
  { 0x62004f, CODE_FOR_sqrtv2sf2 },
  { 0x620050, CODE_FOR_sqrtv4sf2 },
  { 0x620051, CODE_FOR_sqrtv2df2 },
  { 0x71000a, CODE_FOR_movqi },
  { 0x71000b, CODE_FOR_movhi },
  { 0x71000c, CODE_FOR_movsi },
  { 0x71000d, CODE_FOR_movdi },
  { 0x71000e, CODE_FOR_movti },
  { 0x710010, CODE_FOR_movoi },
  { 0x710011, CODE_FOR_movci },
  { 0x710012, CODE_FOR_movxi },
  { 0x710025, CODE_FOR_movsf },
  { 0x710026, CODE_FOR_movdf },
  { 0x710027, CODE_FOR_movtf },
  { 0x710037, CODE_FOR_movv8qi },
  { 0x710038, CODE_FOR_movv4hi },
  { 0x710039, CODE_FOR_movv2si },
  { 0x71003a, CODE_FOR_movv16qi },
  { 0x71003b, CODE_FOR_movv8hi },
  { 0x71003c, CODE_FOR_movv4si },
  { 0x71003d, CODE_FOR_movv2di },
  { 0x71004f, CODE_FOR_movv2sf },
  { 0x710050, CODE_FOR_movv4sf },
  { 0x710051, CODE_FOR_movv2df },
  { 0x730037, CODE_FOR_movmisalignv8qi },
  { 0x730038, CODE_FOR_movmisalignv4hi },
  { 0x730039, CODE_FOR_movmisalignv2si },
  { 0x73003a, CODE_FOR_movmisalignv16qi },
  { 0x73003b, CODE_FOR_movmisalignv8hi },
  { 0x73003c, CODE_FOR_movmisalignv4si },
  { 0x73003d, CODE_FOR_movmisalignv2di },
  { 0x73004f, CODE_FOR_movmisalignv2sf },
  { 0x730050, CODE_FOR_movmisalignv4sf },
  { 0x730051, CODE_FOR_movmisalignv2df },
  { 0x7e000c, CODE_FOR_cbranchsi4 },
  { 0x7e000d, CODE_FOR_cbranchdi4 },
  { 0x7e0025, CODE_FOR_cbranchsf4 },
  { 0x7e0026, CODE_FOR_cbranchdf4 },
  { 0x80000a, CODE_FOR_movqicc },
  { 0x80000b, CODE_FOR_movhicc },
  { 0x80000c, CODE_FOR_movsicc },
  { 0x80000d, CODE_FOR_movdicc },
  { 0x81000c, CODE_FOR_cmovsi6 },
  { 0x81000d, CODE_FOR_cmovdi6 },
  { 0x810025, CODE_FOR_cmovsf6 },
  { 0x810026, CODE_FOR_cmovdf6 },
  { 0x82000c, CODE_FOR_cstoresi4 },
  { 0x82000d, CODE_FOR_cstoredi4 },
  { 0x820025, CODE_FOR_cstoresf4 },
  { 0x820026, CODE_FOR_cstoredf4 },
  { 0x84000d, CODE_FOR_smuldi3_highpart },
  { 0x85000d, CODE_FOR_umuldi3_highpart },
  { 0x8c0025, CODE_FOR_fmasf4 },
  { 0x8c0026, CODE_FOR_fmadf4 },
  { 0x8c004f, CODE_FOR_fmav2sf4 },
  { 0x8c0050, CODE_FOR_fmav4sf4 },
  { 0x8c0051, CODE_FOR_fmav2df4 },
  { 0x8d0025, CODE_FOR_fmssf4 },
  { 0x8d0026, CODE_FOR_fmsdf4 },
  { 0x8e0025, CODE_FOR_fnmasf4 },
  { 0x8e0026, CODE_FOR_fnmadf4 },
  { 0x8f0025, CODE_FOR_fnmssf4 },
  { 0x8f0026, CODE_FOR_fnmsdf4 },
  { 0x900025, CODE_FOR_rintsf2 },
  { 0x900026, CODE_FOR_rintdf2 },
  { 0x90004f, CODE_FOR_rintv2sf2 },
  { 0x900050, CODE_FOR_rintv4sf2 },
  { 0x900051, CODE_FOR_rintv2df2 },
  { 0x910025, CODE_FOR_roundsf2 },
  { 0x910026, CODE_FOR_rounddf2 },
  { 0x91004f, CODE_FOR_roundv2sf2 },
  { 0x910050, CODE_FOR_roundv4sf2 },
  { 0x910051, CODE_FOR_roundv2df2 },
  { 0x920025, CODE_FOR_floorsf2 },
  { 0x920026, CODE_FOR_floordf2 },
  { 0x92004f, CODE_FOR_floorv2sf2 },
  { 0x920050, CODE_FOR_floorv4sf2 },
  { 0x920051, CODE_FOR_floorv2df2 },
  { 0x930025, CODE_FOR_ceilsf2 },
  { 0x930026, CODE_FOR_ceildf2 },
  { 0x93004f, CODE_FOR_ceilv2sf2 },
  { 0x930050, CODE_FOR_ceilv4sf2 },
  { 0x930051, CODE_FOR_ceilv2df2 },
  { 0x940025, CODE_FOR_btruncsf2 },
  { 0x940026, CODE_FOR_btruncdf2 },
  { 0x94004f, CODE_FOR_btruncv2sf2 },
  { 0x940050, CODE_FOR_btruncv4sf2 },
  { 0x940051, CODE_FOR_btruncv2df2 },
  { 0x950025, CODE_FOR_nearbyintsf2 },
  { 0x950026, CODE_FOR_nearbyintdf2 },
  { 0x95004f, CODE_FOR_nearbyintv2sf2 },
  { 0x950050, CODE_FOR_nearbyintv4sf2 },
  { 0x950051, CODE_FOR_nearbyintv2df2 },
  { 0xb10037, CODE_FOR_reduc_smax_v8qi },
  { 0xb10038, CODE_FOR_reduc_smax_v4hi },
  { 0xb10039, CODE_FOR_reduc_smax_v2si },
  { 0xb1003a, CODE_FOR_reduc_smax_v16qi },
  { 0xb1003b, CODE_FOR_reduc_smax_v8hi },
  { 0xb1003c, CODE_FOR_reduc_smax_v4si },
  { 0xb1004f, CODE_FOR_reduc_smax_v2sf },
  { 0xb10050, CODE_FOR_reduc_smax_v4sf },
  { 0xb10051, CODE_FOR_reduc_smax_v2df },
  { 0xb20037, CODE_FOR_reduc_smin_v8qi },
  { 0xb20038, CODE_FOR_reduc_smin_v4hi },
  { 0xb20039, CODE_FOR_reduc_smin_v2si },
  { 0xb2003a, CODE_FOR_reduc_smin_v16qi },
  { 0xb2003b, CODE_FOR_reduc_smin_v8hi },
  { 0xb2003c, CODE_FOR_reduc_smin_v4si },
  { 0xb2004f, CODE_FOR_reduc_smin_v2sf },
  { 0xb20050, CODE_FOR_reduc_smin_v4sf },
  { 0xb20051, CODE_FOR_reduc_smin_v2df },
  { 0xb30037, CODE_FOR_reduc_splus_v8qi },
  { 0xb30038, CODE_FOR_reduc_splus_v4hi },
  { 0xb30039, CODE_FOR_reduc_splus_v2si },
  { 0xb3003a, CODE_FOR_reduc_splus_v16qi },
  { 0xb3003b, CODE_FOR_reduc_splus_v8hi },
  { 0xb3003c, CODE_FOR_reduc_splus_v4si },
  { 0xb3003d, CODE_FOR_reduc_splus_v2di },
  { 0xb3004f, CODE_FOR_reduc_splus_v2sf },
  { 0xb30050, CODE_FOR_reduc_splus_v4sf },
  { 0xb30051, CODE_FOR_reduc_splus_v2df },
  { 0xb40037, CODE_FOR_reduc_umax_v8qi },
  { 0xb40038, CODE_FOR_reduc_umax_v4hi },
  { 0xb40039, CODE_FOR_reduc_umax_v2si },
  { 0xb4003a, CODE_FOR_reduc_umax_v16qi },
  { 0xb4003b, CODE_FOR_reduc_umax_v8hi },
  { 0xb4003c, CODE_FOR_reduc_umax_v4si },
  { 0xb50037, CODE_FOR_reduc_umin_v8qi },
  { 0xb50038, CODE_FOR_reduc_umin_v4hi },
  { 0xb50039, CODE_FOR_reduc_umin_v2si },
  { 0xb5003a, CODE_FOR_reduc_umin_v16qi },
  { 0xb5003b, CODE_FOR_reduc_umin_v8hi },
  { 0xb5003c, CODE_FOR_reduc_umin_v4si },
  { 0xb60037, CODE_FOR_reduc_uplus_v8qi },
  { 0xb60038, CODE_FOR_reduc_uplus_v4hi },
  { 0xb60039, CODE_FOR_reduc_uplus_v2si },
  { 0xb6003a, CODE_FOR_reduc_uplus_v16qi },
  { 0xb6003b, CODE_FOR_reduc_uplus_v8hi },
  { 0xb6003c, CODE_FOR_reduc_uplus_v4si },
  { 0xb6003d, CODE_FOR_reduc_uplus_v2di },
  { 0xb6004f, CODE_FOR_reduc_uplus_v2sf },
  { 0xb60050, CODE_FOR_reduc_uplus_v4sf },
  { 0xb60051, CODE_FOR_reduc_uplus_v2df },
  { 0xbc0037, CODE_FOR_vec_initv8qi },
  { 0xbc0038, CODE_FOR_vec_initv4hi },
  { 0xbc0039, CODE_FOR_vec_initv2si },
  { 0xbc003a, CODE_FOR_vec_initv16qi },
  { 0xbc003b, CODE_FOR_vec_initv8hi },
  { 0xbc003c, CODE_FOR_vec_initv4si },
  { 0xbc003d, CODE_FOR_vec_initv2di },
  { 0xbc004f, CODE_FOR_vec_initv2sf },
  { 0xbc0050, CODE_FOR_vec_initv4sf },
  { 0xbc0051, CODE_FOR_vec_initv2df },
  { 0xbf000d, CODE_FOR_vec_pack_trunc_di },
  { 0xbf0026, CODE_FOR_vec_pack_trunc_df },
  { 0xbf0038, CODE_FOR_vec_pack_trunc_v4hi },
  { 0xbf0039, CODE_FOR_vec_pack_trunc_v2si },
  { 0xbf003b, CODE_FOR_vec_pack_trunc_v8hi },
  { 0xbf003c, CODE_FOR_vec_pack_trunc_v4si },
  { 0xbf003d, CODE_FOR_vec_pack_trunc_v2di },
  { 0xbf0051, CODE_FOR_vec_pack_trunc_v2df },
  { 0xc20037, CODE_FOR_vec_perm_constv8qi },
  { 0xc20038, CODE_FOR_vec_perm_constv4hi },
  { 0xc20039, CODE_FOR_vec_perm_constv2si },
  { 0xc2003a, CODE_FOR_vec_perm_constv16qi },
  { 0xc2003b, CODE_FOR_vec_perm_constv8hi },
  { 0xc2003c, CODE_FOR_vec_perm_constv4si },
  { 0xc2003d, CODE_FOR_vec_perm_constv2di },
  { 0xc2004f, CODE_FOR_vec_perm_constv2sf },
  { 0xc20050, CODE_FOR_vec_perm_constv4sf },
  { 0xc20051, CODE_FOR_vec_perm_constv2df },
  { 0xc30037, CODE_FOR_vec_permv8qi },
  { 0xc3003a, CODE_FOR_vec_permv16qi },
  { 0xc50037, CODE_FOR_vec_setv8qi },
  { 0xc50038, CODE_FOR_vec_setv4hi },
  { 0xc50039, CODE_FOR_vec_setv2si },
  { 0xc5003a, CODE_FOR_vec_setv16qi },
  { 0xc5003b, CODE_FOR_vec_setv8hi },
  { 0xc5003c, CODE_FOR_vec_setv4si },
  { 0xc5003d, CODE_FOR_vec_setv2di },
  { 0xc5004f, CODE_FOR_vec_setv2sf },
  { 0xc50050, CODE_FOR_vec_setv4sf },
  { 0xc50051, CODE_FOR_vec_setv2df },
  { 0xca003a, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0xca003b, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0xca003c, CODE_FOR_vec_unpacks_hi_v4si },
  { 0xca0050, CODE_FOR_vec_unpacks_hi_v4sf },
  { 0xcb003a, CODE_FOR_vec_unpacks_lo_v16qi },
  { 0xcb003b, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0xcb003c, CODE_FOR_vec_unpacks_lo_v4si },
  { 0xcb0050, CODE_FOR_vec_unpacks_lo_v4sf },
  { 0xce003a, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0xce003b, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0xce003c, CODE_FOR_vec_unpacku_hi_v4si },
  { 0xcf003a, CODE_FOR_vec_unpacku_lo_v16qi },
  { 0xcf003b, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0xcf003c, CODE_FOR_vec_unpacku_lo_v4si },
  { 0xd1003a, CODE_FOR_vec_widen_smult_hi_v16qi },
  { 0xd1003b, CODE_FOR_vec_widen_smult_hi_v8hi },
  { 0xd1003c, CODE_FOR_vec_widen_smult_hi_v4si },
  { 0xd2003a, CODE_FOR_vec_widen_smult_lo_v16qi },
  { 0xd2003b, CODE_FOR_vec_widen_smult_lo_v8hi },
  { 0xd2003c, CODE_FOR_vec_widen_smult_lo_v4si },
  { 0xd7003a, CODE_FOR_vec_widen_umult_hi_v16qi },
  { 0xd7003b, CODE_FOR_vec_widen_umult_hi_v8hi },
  { 0xd7003c, CODE_FOR_vec_widen_umult_hi_v4si },
  { 0xd8003a, CODE_FOR_vec_widen_umult_lo_v16qi },
  { 0xd8003b, CODE_FOR_vec_widen_umult_lo_v8hi },
  { 0xd8003c, CODE_FOR_vec_widen_umult_lo_v4si },
  { 0xe3000a, CODE_FOR_atomic_add_fetchqi },
  { 0xe3000b, CODE_FOR_atomic_add_fetchhi },
  { 0xe3000c, CODE_FOR_atomic_add_fetchsi },
  { 0xe3000d, CODE_FOR_atomic_add_fetchdi },
  { 0xe4000a, CODE_FOR_atomic_addqi },
  { 0xe4000b, CODE_FOR_atomic_addhi },
  { 0xe4000c, CODE_FOR_atomic_addsi },
  { 0xe4000d, CODE_FOR_atomic_adddi },
  { 0xe5000a, CODE_FOR_atomic_and_fetchqi },
  { 0xe5000b, CODE_FOR_atomic_and_fetchhi },
  { 0xe5000c, CODE_FOR_atomic_and_fetchsi },
  { 0xe5000d, CODE_FOR_atomic_and_fetchdi },
  { 0xe6000a, CODE_FOR_atomic_andqi },
  { 0xe6000b, CODE_FOR_atomic_andhi },
  { 0xe6000c, CODE_FOR_atomic_andsi },
  { 0xe6000d, CODE_FOR_atomic_anddi },
  { 0xe7000a, CODE_FOR_atomic_compare_and_swapqi },
  { 0xe7000b, CODE_FOR_atomic_compare_and_swaphi },
  { 0xe7000c, CODE_FOR_atomic_compare_and_swapsi },
  { 0xe7000d, CODE_FOR_atomic_compare_and_swapdi },
  { 0xe8000a, CODE_FOR_atomic_exchangeqi },
  { 0xe8000b, CODE_FOR_atomic_exchangehi },
  { 0xe8000c, CODE_FOR_atomic_exchangesi },
  { 0xe8000d, CODE_FOR_atomic_exchangedi },
  { 0xe9000a, CODE_FOR_atomic_fetch_addqi },
  { 0xe9000b, CODE_FOR_atomic_fetch_addhi },
  { 0xe9000c, CODE_FOR_atomic_fetch_addsi },
  { 0xe9000d, CODE_FOR_atomic_fetch_adddi },
  { 0xea000a, CODE_FOR_atomic_fetch_andqi },
  { 0xea000b, CODE_FOR_atomic_fetch_andhi },
  { 0xea000c, CODE_FOR_atomic_fetch_andsi },
  { 0xea000d, CODE_FOR_atomic_fetch_anddi },
  { 0xeb000a, CODE_FOR_atomic_fetch_nandqi },
  { 0xeb000b, CODE_FOR_atomic_fetch_nandhi },
  { 0xeb000c, CODE_FOR_atomic_fetch_nandsi },
  { 0xeb000d, CODE_FOR_atomic_fetch_nanddi },
  { 0xec000a, CODE_FOR_atomic_fetch_orqi },
  { 0xec000b, CODE_FOR_atomic_fetch_orhi },
  { 0xec000c, CODE_FOR_atomic_fetch_orsi },
  { 0xec000d, CODE_FOR_atomic_fetch_ordi },
  { 0xed000a, CODE_FOR_atomic_fetch_subqi },
  { 0xed000b, CODE_FOR_atomic_fetch_subhi },
  { 0xed000c, CODE_FOR_atomic_fetch_subsi },
  { 0xed000d, CODE_FOR_atomic_fetch_subdi },
  { 0xee000a, CODE_FOR_atomic_fetch_xorqi },
  { 0xee000b, CODE_FOR_atomic_fetch_xorhi },
  { 0xee000c, CODE_FOR_atomic_fetch_xorsi },
  { 0xee000d, CODE_FOR_atomic_fetch_xordi },
  { 0xef000a, CODE_FOR_atomic_loadqi },
  { 0xef000b, CODE_FOR_atomic_loadhi },
  { 0xef000c, CODE_FOR_atomic_loadsi },
  { 0xef000d, CODE_FOR_atomic_loaddi },
  { 0xf0000a, CODE_FOR_atomic_nand_fetchqi },
  { 0xf0000b, CODE_FOR_atomic_nand_fetchhi },
  { 0xf0000c, CODE_FOR_atomic_nand_fetchsi },
  { 0xf0000d, CODE_FOR_atomic_nand_fetchdi },
  { 0xf1000a, CODE_FOR_atomic_nandqi },
  { 0xf1000b, CODE_FOR_atomic_nandhi },
  { 0xf1000c, CODE_FOR_atomic_nandsi },
  { 0xf1000d, CODE_FOR_atomic_nanddi },
  { 0xf2000a, CODE_FOR_atomic_or_fetchqi },
  { 0xf2000b, CODE_FOR_atomic_or_fetchhi },
  { 0xf2000c, CODE_FOR_atomic_or_fetchsi },
  { 0xf2000d, CODE_FOR_atomic_or_fetchdi },
  { 0xf3000a, CODE_FOR_atomic_orqi },
  { 0xf3000b, CODE_FOR_atomic_orhi },
  { 0xf3000c, CODE_FOR_atomic_orsi },
  { 0xf3000d, CODE_FOR_atomic_ordi },
  { 0xf4000a, CODE_FOR_atomic_storeqi },
  { 0xf4000b, CODE_FOR_atomic_storehi },
  { 0xf4000c, CODE_FOR_atomic_storesi },
  { 0xf4000d, CODE_FOR_atomic_storedi },
  { 0xf5000a, CODE_FOR_atomic_sub_fetchqi },
  { 0xf5000b, CODE_FOR_atomic_sub_fetchhi },
  { 0xf5000c, CODE_FOR_atomic_sub_fetchsi },
  { 0xf5000d, CODE_FOR_atomic_sub_fetchdi },
  { 0xf6000a, CODE_FOR_atomic_subqi },
  { 0xf6000b, CODE_FOR_atomic_subhi },
  { 0xf6000c, CODE_FOR_atomic_subsi },
  { 0xf6000d, CODE_FOR_atomic_subdi },
  { 0xf7000a, CODE_FOR_atomic_xor_fetchqi },
  { 0xf7000b, CODE_FOR_atomic_xor_fetchhi },
  { 0xf7000c, CODE_FOR_atomic_xor_fetchsi },
  { 0xf7000d, CODE_FOR_atomic_xor_fetchdi },
  { 0xf8000a, CODE_FOR_atomic_xorqi },
  { 0xf8000b, CODE_FOR_atomic_xorhi },
  { 0xf8000c, CODE_FOR_atomic_xorsi },
  { 0xf8000d, CODE_FOR_atomic_xordi },
  { 0xf9000d, CODE_FOR_get_thread_pointerdi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_truncdfsf2;
  ena[8] = HAVE_zero_extendqihi2;
  ena[9] = HAVE_zero_extendqisi2;
  ena[10] = HAVE_zero_extendqidi2;
  ena[11] = HAVE_zero_extendhisi2;
  ena[12] = HAVE_zero_extendhidi2;
  ena[13] = HAVE_zero_extendsidi2;
  ena[14] = HAVE_fixv2sfv2si2;
  ena[15] = HAVE_fixv4sfv4si2;
  ena[16] = HAVE_fixv2dfv2di2;
  ena[17] = HAVE_fixunsv2sfv2si2;
  ena[18] = HAVE_fixunsv4sfv4si2;
  ena[19] = HAVE_fixunsv2dfv2di2;
  ena[20] = HAVE_floatsisf2;
  ena[21] = HAVE_floatsidf2;
  ena[22] = HAVE_floatdisf2;
  ena[23] = HAVE_floatdidf2;
  ena[24] = HAVE_floatv2siv2sf2;
  ena[25] = HAVE_floatv4siv4sf2;
  ena[26] = HAVE_floatv2div2df2;
  ena[27] = HAVE_floatunssisf2;
  ena[28] = HAVE_floatunssidf2;
  ena[29] = HAVE_floatunsdisf2;
  ena[30] = HAVE_floatunsdidf2;
  ena[31] = HAVE_floatunsv2siv2sf2;
  ena[32] = HAVE_floatunsv4siv4sf2;
  ena[33] = HAVE_floatunsv2div2df2;
  ena[34] = HAVE_lroundsfsi2;
  ena[35] = HAVE_lroundsfdi2;
  ena[36] = HAVE_lrounddfsi2;
  ena[37] = HAVE_lrounddfdi2;
  ena[38] = HAVE_lroundv2sfv2si2;
  ena[39] = HAVE_lroundv4sfv4si2;
  ena[40] = HAVE_lroundv2dfv2di2;
  ena[41] = HAVE_lfloorsfsi2;
  ena[42] = HAVE_lfloorsfdi2;
  ena[43] = HAVE_lfloordfsi2;
  ena[44] = HAVE_lfloordfdi2;
  ena[45] = HAVE_lfloorv2sfv2si2;
  ena[46] = HAVE_lfloorv4sfv4si2;
  ena[47] = HAVE_lfloorv2dfv2di2;
  ena[48] = HAVE_lceilsfsi2;
  ena[49] = HAVE_lceilsfdi2;
  ena[50] = HAVE_lceildfsi2;
  ena[51] = HAVE_lceildfdi2;
  ena[52] = HAVE_lceilv2sfv2si2;
  ena[53] = HAVE_lceilv4sfv4si2;
  ena[54] = HAVE_lceilv2dfv2di2;
  ena[55] = HAVE_fix_truncsfsi2;
  ena[56] = HAVE_fix_truncsfdi2;
  ena[57] = HAVE_fix_truncdfsi2;
  ena[58] = HAVE_fix_truncdfdi2;
  ena[59] = HAVE_fix_truncv2sfv2si2;
  ena[60] = HAVE_fix_truncv4sfv4si2;
  ena[61] = HAVE_fix_truncv2dfv2di2;
  ena[62] = HAVE_fixuns_truncsfsi2;
  ena[63] = HAVE_fixuns_truncsfdi2;
  ena[64] = HAVE_fixuns_truncdfsi2;
  ena[65] = HAVE_fixuns_truncdfdi2;
  ena[66] = HAVE_fixuns_truncv2sfv2si2;
  ena[67] = HAVE_fixuns_truncv4sfv4si2;
  ena[68] = HAVE_fixuns_truncv2dfv2di2;
  ena[69] = HAVE_mulsidi3;
  ena[70] = HAVE_umulsidi3;
  ena[71] = HAVE_maddsidi4;
  ena[72] = HAVE_umaddsidi4;
  ena[73] = HAVE_msubsidi4;
  ena[74] = HAVE_umsubsidi4;
  ena[75] = HAVE_vec_load_lanesoiv16qi;
  ena[76] = HAVE_vec_load_lanesciv16qi;
  ena[77] = HAVE_vec_load_lanesxiv16qi;
  ena[78] = HAVE_vec_load_lanesoiv8hi;
  ena[79] = HAVE_vec_load_lanesciv8hi;
  ena[80] = HAVE_vec_load_lanesxiv8hi;
  ena[81] = HAVE_vec_load_lanesoiv4si;
  ena[82] = HAVE_vec_load_lanesciv4si;
  ena[83] = HAVE_vec_load_lanesxiv4si;
  ena[84] = HAVE_vec_load_lanesoiv2di;
  ena[85] = HAVE_vec_load_lanesciv2di;
  ena[86] = HAVE_vec_load_lanesxiv2di;
  ena[87] = HAVE_vec_load_lanesoiv4sf;
  ena[88] = HAVE_vec_load_lanesciv4sf;
  ena[89] = HAVE_vec_load_lanesxiv4sf;
  ena[90] = HAVE_vec_load_lanesoiv2df;
  ena[91] = HAVE_vec_load_lanesciv2df;
  ena[92] = HAVE_vec_load_lanesxiv2df;
  ena[93] = HAVE_vec_store_lanesoiv16qi;
  ena[94] = HAVE_vec_store_lanesciv16qi;
  ena[95] = HAVE_vec_store_lanesxiv16qi;
  ena[96] = HAVE_vec_store_lanesoiv8hi;
  ena[97] = HAVE_vec_store_lanesciv8hi;
  ena[98] = HAVE_vec_store_lanesxiv8hi;
  ena[99] = HAVE_vec_store_lanesoiv4si;
  ena[100] = HAVE_vec_store_lanesciv4si;
  ena[101] = HAVE_vec_store_lanesxiv4si;
  ena[102] = HAVE_vec_store_lanesoiv2di;
  ena[103] = HAVE_vec_store_lanesciv2di;
  ena[104] = HAVE_vec_store_lanesxiv2di;
  ena[105] = HAVE_vec_store_lanesoiv4sf;
  ena[106] = HAVE_vec_store_lanesciv4sf;
  ena[107] = HAVE_vec_store_lanesxiv4sf;
  ena[108] = HAVE_vec_store_lanesoiv2df;
  ena[109] = HAVE_vec_store_lanesciv2df;
  ena[110] = HAVE_vec_store_lanesxiv2df;
  ena[111] = HAVE_vcondv8qiv8qi;
  ena[112] = HAVE_vcondv4hiv4hi;
  ena[113] = HAVE_vcondv2siv2si;
  ena[114] = HAVE_vcondv16qiv16qi;
  ena[115] = HAVE_vcondv8hiv8hi;
  ena[116] = HAVE_vcondv4siv4si;
  ena[117] = HAVE_vcondv2div2di;
  ena[118] = HAVE_vcondv2siv2sf;
  ena[119] = HAVE_vcondv2sfv2sf;
  ena[120] = HAVE_vcondv4siv4sf;
  ena[121] = HAVE_vcondv4sfv4sf;
  ena[122] = HAVE_vcondv2div2df;
  ena[123] = HAVE_vcondv2dfv2df;
  ena[124] = HAVE_vconduv8qiv8qi;
  ena[125] = HAVE_vconduv4hiv4hi;
  ena[126] = HAVE_vconduv2siv2si;
  ena[127] = HAVE_vconduv16qiv16qi;
  ena[128] = HAVE_vconduv8hiv8hi;
  ena[129] = HAVE_vconduv4siv4si;
  ena[130] = HAVE_vconduv2div2di;
  ena[131] = HAVE_addsi3;
  ena[132] = HAVE_adddi3;
  ena[133] = HAVE_addsf3;
  ena[134] = HAVE_adddf3;
  ena[135] = HAVE_addv8qi3;
  ena[136] = HAVE_addv4hi3;
  ena[137] = HAVE_addv2si3;
  ena[138] = HAVE_addv16qi3;
  ena[139] = HAVE_addv8hi3;
  ena[140] = HAVE_addv4si3;
  ena[141] = HAVE_addv2di3;
  ena[142] = HAVE_addv2sf3;
  ena[143] = HAVE_addv4sf3;
  ena[144] = HAVE_addv2df3;
  ena[145] = HAVE_subsi3;
  ena[146] = HAVE_subdi3;
  ena[147] = HAVE_subsf3;
  ena[148] = HAVE_subdf3;
  ena[149] = HAVE_subv8qi3;
  ena[150] = HAVE_subv4hi3;
  ena[151] = HAVE_subv2si3;
  ena[152] = HAVE_subv16qi3;
  ena[153] = HAVE_subv8hi3;
  ena[154] = HAVE_subv4si3;
  ena[155] = HAVE_subv2di3;
  ena[156] = HAVE_subv2sf3;
  ena[157] = HAVE_subv4sf3;
  ena[158] = HAVE_subv2df3;
  ena[159] = HAVE_mulsi3;
  ena[160] = HAVE_muldi3;
  ena[161] = HAVE_mulsf3;
  ena[162] = HAVE_muldf3;
  ena[163] = HAVE_mulv8qi3;
  ena[164] = HAVE_mulv4hi3;
  ena[165] = HAVE_mulv2si3;
  ena[166] = HAVE_mulv16qi3;
  ena[167] = HAVE_mulv8hi3;
  ena[168] = HAVE_mulv4si3;
  ena[169] = HAVE_mulv2sf3;
  ena[170] = HAVE_mulv4sf3;
  ena[171] = HAVE_mulv2df3;
  ena[172] = HAVE_divsi3;
  ena[173] = HAVE_divdi3;
  ena[174] = HAVE_divsf3;
  ena[175] = HAVE_divdf3;
  ena[176] = HAVE_divv2sf3;
  ena[177] = HAVE_divv4sf3;
  ena[178] = HAVE_divv2df3;
  ena[179] = HAVE_udivsi3;
  ena[180] = HAVE_udivdi3;
  ena[181] = HAVE_ftruncv2sf2;
  ena[182] = HAVE_ftruncv4sf2;
  ena[183] = HAVE_ftruncv2df2;
  ena[184] = HAVE_andsi3;
  ena[185] = HAVE_anddi3;
  ena[186] = HAVE_andv8qi3;
  ena[187] = HAVE_andv4hi3;
  ena[188] = HAVE_andv2si3;
  ena[189] = HAVE_andv16qi3;
  ena[190] = HAVE_andv8hi3;
  ena[191] = HAVE_andv4si3;
  ena[192] = HAVE_andv2di3;
  ena[193] = HAVE_iorsi3;
  ena[194] = HAVE_iordi3;
  ena[195] = HAVE_iorv8qi3;
  ena[196] = HAVE_iorv4hi3;
  ena[197] = HAVE_iorv2si3;
  ena[198] = HAVE_iorv16qi3;
  ena[199] = HAVE_iorv8hi3;
  ena[200] = HAVE_iorv4si3;
  ena[201] = HAVE_iorv2di3;
  ena[202] = HAVE_xorsi3;
  ena[203] = HAVE_xordi3;
  ena[204] = HAVE_xorv8qi3;
  ena[205] = HAVE_xorv4hi3;
  ena[206] = HAVE_xorv2si3;
  ena[207] = HAVE_xorv16qi3;
  ena[208] = HAVE_xorv8hi3;
  ena[209] = HAVE_xorv4si3;
  ena[210] = HAVE_xorv2di3;
  ena[211] = HAVE_ashlqi3;
  ena[212] = HAVE_ashlhi3;
  ena[213] = HAVE_ashlsi3;
  ena[214] = HAVE_ashldi3;
  ena[215] = HAVE_ashlv8qi3;
  ena[216] = HAVE_ashlv4hi3;
  ena[217] = HAVE_ashlv2si3;
  ena[218] = HAVE_ashlv16qi3;
  ena[219] = HAVE_ashlv8hi3;
  ena[220] = HAVE_ashlv4si3;
  ena[221] = HAVE_ashlv2di3;
  ena[222] = HAVE_ashrsi3;
  ena[223] = HAVE_ashrdi3;
  ena[224] = HAVE_ashrv8qi3;
  ena[225] = HAVE_ashrv4hi3;
  ena[226] = HAVE_ashrv2si3;
  ena[227] = HAVE_ashrv16qi3;
  ena[228] = HAVE_ashrv8hi3;
  ena[229] = HAVE_ashrv4si3;
  ena[230] = HAVE_ashrv2di3;
  ena[231] = HAVE_lshrsi3;
  ena[232] = HAVE_lshrdi3;
  ena[233] = HAVE_lshrv8qi3;
  ena[234] = HAVE_lshrv4hi3;
  ena[235] = HAVE_lshrv2si3;
  ena[236] = HAVE_lshrv16qi3;
  ena[237] = HAVE_lshrv8hi3;
  ena[238] = HAVE_lshrv4si3;
  ena[239] = HAVE_lshrv2di3;
  ena[240] = HAVE_rotlsi3;
  ena[241] = HAVE_rotldi3;
  ena[242] = HAVE_rotrsi3;
  ena[243] = HAVE_rotrdi3;
  ena[244] = HAVE_vashlv8qi3;
  ena[245] = HAVE_vashlv4hi3;
  ena[246] = HAVE_vashlv2si3;
  ena[247] = HAVE_vashlv16qi3;
  ena[248] = HAVE_vashlv8hi3;
  ena[249] = HAVE_vashlv4si3;
  ena[250] = HAVE_vashlv2di3;
  ena[251] = HAVE_vashrv8qi3;
  ena[252] = HAVE_vashrv4hi3;
  ena[253] = HAVE_vashrv2si3;
  ena[254] = HAVE_vashrv16qi3;
  ena[255] = HAVE_vashrv8hi3;
  ena[256] = HAVE_vashrv4si3;
  ena[257] = HAVE_vlshrv8qi3;
  ena[258] = HAVE_vlshrv4hi3;
  ena[259] = HAVE_vlshrv2si3;
  ena[260] = HAVE_vlshrv16qi3;
  ena[261] = HAVE_vlshrv8hi3;
  ena[262] = HAVE_vlshrv4si3;
  ena[263] = HAVE_sminsf3;
  ena[264] = HAVE_smindf3;
  ena[265] = HAVE_sminv8qi3;
  ena[266] = HAVE_sminv4hi3;
  ena[267] = HAVE_sminv2si3;
  ena[268] = HAVE_sminv16qi3;
  ena[269] = HAVE_sminv8hi3;
  ena[270] = HAVE_sminv4si3;
  ena[271] = HAVE_sminv2sf3;
  ena[272] = HAVE_sminv4sf3;
  ena[273] = HAVE_sminv2df3;
  ena[274] = HAVE_smaxsf3;
  ena[275] = HAVE_smaxdf3;
  ena[276] = HAVE_smaxv8qi3;
  ena[277] = HAVE_smaxv4hi3;
  ena[278] = HAVE_smaxv2si3;
  ena[279] = HAVE_smaxv16qi3;
  ena[280] = HAVE_smaxv8hi3;
  ena[281] = HAVE_smaxv4si3;
  ena[282] = HAVE_smaxv2sf3;
  ena[283] = HAVE_smaxv4sf3;
  ena[284] = HAVE_smaxv2df3;
  ena[285] = HAVE_uminv8qi3;
  ena[286] = HAVE_uminv4hi3;
  ena[287] = HAVE_uminv2si3;
  ena[288] = HAVE_uminv16qi3;
  ena[289] = HAVE_uminv8hi3;
  ena[290] = HAVE_uminv4si3;
  ena[291] = HAVE_umaxv8qi3;
  ena[292] = HAVE_umaxv4hi3;
  ena[293] = HAVE_umaxv2si3;
  ena[294] = HAVE_umaxv16qi3;
  ena[295] = HAVE_umaxv8hi3;
  ena[296] = HAVE_umaxv4si3;
  ena[297] = HAVE_negsi2;
  ena[298] = HAVE_negdi2;
  ena[299] = HAVE_negsf2;
  ena[300] = HAVE_negdf2;
  ena[301] = HAVE_negv8qi2;
  ena[302] = HAVE_negv4hi2;
  ena[303] = HAVE_negv2si2;
  ena[304] = HAVE_negv16qi2;
  ena[305] = HAVE_negv8hi2;
  ena[306] = HAVE_negv4si2;
  ena[307] = HAVE_negv2di2;
  ena[308] = HAVE_negv2sf2;
  ena[309] = HAVE_negv4sf2;
  ena[310] = HAVE_negv2df2;
  ena[311] = HAVE_abssf2;
  ena[312] = HAVE_absdf2;
  ena[313] = HAVE_absv8qi2;
  ena[314] = HAVE_absv4hi2;
  ena[315] = HAVE_absv2si2;
  ena[316] = HAVE_absv16qi2;
  ena[317] = HAVE_absv8hi2;
  ena[318] = HAVE_absv4si2;
  ena[319] = HAVE_absv2di2;
  ena[320] = HAVE_absv2sf2;
  ena[321] = HAVE_absv4sf2;
  ena[322] = HAVE_absv2df2;
  ena[323] = HAVE_one_cmplsi2;
  ena[324] = HAVE_one_cmpldi2;
  ena[325] = HAVE_one_cmplv8qi2;
  ena[326] = HAVE_one_cmplv4hi2;
  ena[327] = HAVE_one_cmplv2si2;
  ena[328] = HAVE_one_cmplv16qi2;
  ena[329] = HAVE_one_cmplv8hi2;
  ena[330] = HAVE_one_cmplv4si2;
  ena[331] = HAVE_one_cmplv2di2;
  ena[332] = HAVE_bswaphi2;
  ena[333] = HAVE_bswapsi2;
  ena[334] = HAVE_bswapdi2;
  ena[335] = HAVE_ffssi2;
  ena[336] = HAVE_ffsdi2;
  ena[337] = HAVE_clzsi2;
  ena[338] = HAVE_clzdi2;
  ena[339] = HAVE_ctzsi2;
  ena[340] = HAVE_ctzdi2;
  ena[341] = HAVE_clrsbsi2;
  ena[342] = HAVE_clrsbdi2;
  ena[343] = HAVE_sqrtsf2;
  ena[344] = HAVE_sqrtdf2;
  ena[345] = HAVE_sqrtv2sf2;
  ena[346] = HAVE_sqrtv4sf2;
  ena[347] = HAVE_sqrtv2df2;
  ena[348] = HAVE_movqi;
  ena[349] = HAVE_movhi;
  ena[350] = HAVE_movsi;
  ena[351] = HAVE_movdi;
  ena[352] = HAVE_movti;
  ena[353] = HAVE_movoi;
  ena[354] = HAVE_movci;
  ena[355] = HAVE_movxi;
  ena[356] = HAVE_movsf;
  ena[357] = HAVE_movdf;
  ena[358] = HAVE_movtf;
  ena[359] = HAVE_movv8qi;
  ena[360] = HAVE_movv4hi;
  ena[361] = HAVE_movv2si;
  ena[362] = HAVE_movv16qi;
  ena[363] = HAVE_movv8hi;
  ena[364] = HAVE_movv4si;
  ena[365] = HAVE_movv2di;
  ena[366] = HAVE_movv2sf;
  ena[367] = HAVE_movv4sf;
  ena[368] = HAVE_movv2df;
  ena[369] = HAVE_movmisalignv8qi;
  ena[370] = HAVE_movmisalignv4hi;
  ena[371] = HAVE_movmisalignv2si;
  ena[372] = HAVE_movmisalignv16qi;
  ena[373] = HAVE_movmisalignv8hi;
  ena[374] = HAVE_movmisalignv4si;
  ena[375] = HAVE_movmisalignv2di;
  ena[376] = HAVE_movmisalignv2sf;
  ena[377] = HAVE_movmisalignv4sf;
  ena[378] = HAVE_movmisalignv2df;
  ena[379] = HAVE_cbranchsi4;
  ena[380] = HAVE_cbranchdi4;
  ena[381] = HAVE_cbranchsf4;
  ena[382] = HAVE_cbranchdf4;
  ena[383] = HAVE_movqicc;
  ena[384] = HAVE_movhicc;
  ena[385] = HAVE_movsicc;
  ena[386] = HAVE_movdicc;
  ena[387] = HAVE_cmovsi6;
  ena[388] = HAVE_cmovdi6;
  ena[389] = HAVE_cmovsf6;
  ena[390] = HAVE_cmovdf6;
  ena[391] = HAVE_cstoresi4;
  ena[392] = HAVE_cstoredi4;
  ena[393] = HAVE_cstoresf4;
  ena[394] = HAVE_cstoredf4;
  ena[395] = HAVE_smuldi3_highpart;
  ena[396] = HAVE_umuldi3_highpart;
  ena[397] = HAVE_fmasf4;
  ena[398] = HAVE_fmadf4;
  ena[399] = HAVE_fmav2sf4;
  ena[400] = HAVE_fmav4sf4;
  ena[401] = HAVE_fmav2df4;
  ena[402] = HAVE_fmssf4;
  ena[403] = HAVE_fmsdf4;
  ena[404] = HAVE_fnmasf4;
  ena[405] = HAVE_fnmadf4;
  ena[406] = HAVE_fnmssf4;
  ena[407] = HAVE_fnmsdf4;
  ena[408] = HAVE_rintsf2;
  ena[409] = HAVE_rintdf2;
  ena[410] = HAVE_rintv2sf2;
  ena[411] = HAVE_rintv4sf2;
  ena[412] = HAVE_rintv2df2;
  ena[413] = HAVE_roundsf2;
  ena[414] = HAVE_rounddf2;
  ena[415] = HAVE_roundv2sf2;
  ena[416] = HAVE_roundv4sf2;
  ena[417] = HAVE_roundv2df2;
  ena[418] = HAVE_floorsf2;
  ena[419] = HAVE_floordf2;
  ena[420] = HAVE_floorv2sf2;
  ena[421] = HAVE_floorv4sf2;
  ena[422] = HAVE_floorv2df2;
  ena[423] = HAVE_ceilsf2;
  ena[424] = HAVE_ceildf2;
  ena[425] = HAVE_ceilv2sf2;
  ena[426] = HAVE_ceilv4sf2;
  ena[427] = HAVE_ceilv2df2;
  ena[428] = HAVE_btruncsf2;
  ena[429] = HAVE_btruncdf2;
  ena[430] = HAVE_btruncv2sf2;
  ena[431] = HAVE_btruncv4sf2;
  ena[432] = HAVE_btruncv2df2;
  ena[433] = HAVE_nearbyintsf2;
  ena[434] = HAVE_nearbyintdf2;
  ena[435] = HAVE_nearbyintv2sf2;
  ena[436] = HAVE_nearbyintv4sf2;
  ena[437] = HAVE_nearbyintv2df2;
  ena[438] = HAVE_reduc_smax_v8qi;
  ena[439] = HAVE_reduc_smax_v4hi;
  ena[440] = HAVE_reduc_smax_v2si;
  ena[441] = HAVE_reduc_smax_v16qi;
  ena[442] = HAVE_reduc_smax_v8hi;
  ena[443] = HAVE_reduc_smax_v4si;
  ena[444] = HAVE_reduc_smax_v2sf;
  ena[445] = HAVE_reduc_smax_v4sf;
  ena[446] = HAVE_reduc_smax_v2df;
  ena[447] = HAVE_reduc_smin_v8qi;
  ena[448] = HAVE_reduc_smin_v4hi;
  ena[449] = HAVE_reduc_smin_v2si;
  ena[450] = HAVE_reduc_smin_v16qi;
  ena[451] = HAVE_reduc_smin_v8hi;
  ena[452] = HAVE_reduc_smin_v4si;
  ena[453] = HAVE_reduc_smin_v2sf;
  ena[454] = HAVE_reduc_smin_v4sf;
  ena[455] = HAVE_reduc_smin_v2df;
  ena[456] = HAVE_reduc_splus_v8qi;
  ena[457] = HAVE_reduc_splus_v4hi;
  ena[458] = HAVE_reduc_splus_v2si;
  ena[459] = HAVE_reduc_splus_v16qi;
  ena[460] = HAVE_reduc_splus_v8hi;
  ena[461] = HAVE_reduc_splus_v4si;
  ena[462] = HAVE_reduc_splus_v2di;
  ena[463] = HAVE_reduc_splus_v2sf;
  ena[464] = HAVE_reduc_splus_v4sf;
  ena[465] = HAVE_reduc_splus_v2df;
  ena[466] = HAVE_reduc_umax_v8qi;
  ena[467] = HAVE_reduc_umax_v4hi;
  ena[468] = HAVE_reduc_umax_v2si;
  ena[469] = HAVE_reduc_umax_v16qi;
  ena[470] = HAVE_reduc_umax_v8hi;
  ena[471] = HAVE_reduc_umax_v4si;
  ena[472] = HAVE_reduc_umin_v8qi;
  ena[473] = HAVE_reduc_umin_v4hi;
  ena[474] = HAVE_reduc_umin_v2si;
  ena[475] = HAVE_reduc_umin_v16qi;
  ena[476] = HAVE_reduc_umin_v8hi;
  ena[477] = HAVE_reduc_umin_v4si;
  ena[478] = HAVE_reduc_uplus_v8qi;
  ena[479] = HAVE_reduc_uplus_v4hi;
  ena[480] = HAVE_reduc_uplus_v2si;
  ena[481] = HAVE_reduc_uplus_v16qi;
  ena[482] = HAVE_reduc_uplus_v8hi;
  ena[483] = HAVE_reduc_uplus_v4si;
  ena[484] = HAVE_reduc_uplus_v2di;
  ena[485] = HAVE_reduc_uplus_v2sf;
  ena[486] = HAVE_reduc_uplus_v4sf;
  ena[487] = HAVE_reduc_uplus_v2df;
  ena[488] = HAVE_vec_initv8qi;
  ena[489] = HAVE_vec_initv4hi;
  ena[490] = HAVE_vec_initv2si;
  ena[491] = HAVE_vec_initv16qi;
  ena[492] = HAVE_vec_initv8hi;
  ena[493] = HAVE_vec_initv4si;
  ena[494] = HAVE_vec_initv2di;
  ena[495] = HAVE_vec_initv2sf;
  ena[496] = HAVE_vec_initv4sf;
  ena[497] = HAVE_vec_initv2df;
  ena[498] = HAVE_vec_pack_trunc_di;
  ena[499] = HAVE_vec_pack_trunc_df;
  ena[500] = HAVE_vec_pack_trunc_v4hi;
  ena[501] = HAVE_vec_pack_trunc_v2si;
  ena[502] = HAVE_vec_pack_trunc_v8hi;
  ena[503] = HAVE_vec_pack_trunc_v4si;
  ena[504] = HAVE_vec_pack_trunc_v2di;
  ena[505] = HAVE_vec_pack_trunc_v2df;
  ena[506] = HAVE_vec_perm_constv8qi;
  ena[507] = HAVE_vec_perm_constv4hi;
  ena[508] = HAVE_vec_perm_constv2si;
  ena[509] = HAVE_vec_perm_constv16qi;
  ena[510] = HAVE_vec_perm_constv8hi;
  ena[511] = HAVE_vec_perm_constv4si;
  ena[512] = HAVE_vec_perm_constv2di;
  ena[513] = HAVE_vec_perm_constv2sf;
  ena[514] = HAVE_vec_perm_constv4sf;
  ena[515] = HAVE_vec_perm_constv2df;
  ena[516] = HAVE_vec_permv8qi;
  ena[517] = HAVE_vec_permv16qi;
  ena[518] = HAVE_vec_setv8qi;
  ena[519] = HAVE_vec_setv4hi;
  ena[520] = HAVE_vec_setv2si;
  ena[521] = HAVE_vec_setv16qi;
  ena[522] = HAVE_vec_setv8hi;
  ena[523] = HAVE_vec_setv4si;
  ena[524] = HAVE_vec_setv2di;
  ena[525] = HAVE_vec_setv2sf;
  ena[526] = HAVE_vec_setv4sf;
  ena[527] = HAVE_vec_setv2df;
  ena[528] = HAVE_vec_unpacks_hi_v16qi;
  ena[529] = HAVE_vec_unpacks_hi_v8hi;
  ena[530] = HAVE_vec_unpacks_hi_v4si;
  ena[531] = HAVE_vec_unpacks_hi_v4sf;
  ena[532] = HAVE_vec_unpacks_lo_v16qi;
  ena[533] = HAVE_vec_unpacks_lo_v8hi;
  ena[534] = HAVE_vec_unpacks_lo_v4si;
  ena[535] = HAVE_vec_unpacks_lo_v4sf;
  ena[536] = HAVE_vec_unpacku_hi_v16qi;
  ena[537] = HAVE_vec_unpacku_hi_v8hi;
  ena[538] = HAVE_vec_unpacku_hi_v4si;
  ena[539] = HAVE_vec_unpacku_lo_v16qi;
  ena[540] = HAVE_vec_unpacku_lo_v8hi;
  ena[541] = HAVE_vec_unpacku_lo_v4si;
  ena[542] = HAVE_vec_widen_smult_hi_v16qi;
  ena[543] = HAVE_vec_widen_smult_hi_v8hi;
  ena[544] = HAVE_vec_widen_smult_hi_v4si;
  ena[545] = HAVE_vec_widen_smult_lo_v16qi;
  ena[546] = HAVE_vec_widen_smult_lo_v8hi;
  ena[547] = HAVE_vec_widen_smult_lo_v4si;
  ena[548] = HAVE_vec_widen_umult_hi_v16qi;
  ena[549] = HAVE_vec_widen_umult_hi_v8hi;
  ena[550] = HAVE_vec_widen_umult_hi_v4si;
  ena[551] = HAVE_vec_widen_umult_lo_v16qi;
  ena[552] = HAVE_vec_widen_umult_lo_v8hi;
  ena[553] = HAVE_vec_widen_umult_lo_v4si;
  ena[554] = HAVE_atomic_add_fetchqi;
  ena[555] = HAVE_atomic_add_fetchhi;
  ena[556] = HAVE_atomic_add_fetchsi;
  ena[557] = HAVE_atomic_add_fetchdi;
  ena[558] = HAVE_atomic_addqi;
  ena[559] = HAVE_atomic_addhi;
  ena[560] = HAVE_atomic_addsi;
  ena[561] = HAVE_atomic_adddi;
  ena[562] = HAVE_atomic_and_fetchqi;
  ena[563] = HAVE_atomic_and_fetchhi;
  ena[564] = HAVE_atomic_and_fetchsi;
  ena[565] = HAVE_atomic_and_fetchdi;
  ena[566] = HAVE_atomic_andqi;
  ena[567] = HAVE_atomic_andhi;
  ena[568] = HAVE_atomic_andsi;
  ena[569] = HAVE_atomic_anddi;
  ena[570] = HAVE_atomic_compare_and_swapqi;
  ena[571] = HAVE_atomic_compare_and_swaphi;
  ena[572] = HAVE_atomic_compare_and_swapsi;
  ena[573] = HAVE_atomic_compare_and_swapdi;
  ena[574] = HAVE_atomic_exchangeqi;
  ena[575] = HAVE_atomic_exchangehi;
  ena[576] = HAVE_atomic_exchangesi;
  ena[577] = HAVE_atomic_exchangedi;
  ena[578] = HAVE_atomic_fetch_addqi;
  ena[579] = HAVE_atomic_fetch_addhi;
  ena[580] = HAVE_atomic_fetch_addsi;
  ena[581] = HAVE_atomic_fetch_adddi;
  ena[582] = HAVE_atomic_fetch_andqi;
  ena[583] = HAVE_atomic_fetch_andhi;
  ena[584] = HAVE_atomic_fetch_andsi;
  ena[585] = HAVE_atomic_fetch_anddi;
  ena[586] = HAVE_atomic_fetch_nandqi;
  ena[587] = HAVE_atomic_fetch_nandhi;
  ena[588] = HAVE_atomic_fetch_nandsi;
  ena[589] = HAVE_atomic_fetch_nanddi;
  ena[590] = HAVE_atomic_fetch_orqi;
  ena[591] = HAVE_atomic_fetch_orhi;
  ena[592] = HAVE_atomic_fetch_orsi;
  ena[593] = HAVE_atomic_fetch_ordi;
  ena[594] = HAVE_atomic_fetch_subqi;
  ena[595] = HAVE_atomic_fetch_subhi;
  ena[596] = HAVE_atomic_fetch_subsi;
  ena[597] = HAVE_atomic_fetch_subdi;
  ena[598] = HAVE_atomic_fetch_xorqi;
  ena[599] = HAVE_atomic_fetch_xorhi;
  ena[600] = HAVE_atomic_fetch_xorsi;
  ena[601] = HAVE_atomic_fetch_xordi;
  ena[602] = HAVE_atomic_loadqi;
  ena[603] = HAVE_atomic_loadhi;
  ena[604] = HAVE_atomic_loadsi;
  ena[605] = HAVE_atomic_loaddi;
  ena[606] = HAVE_atomic_nand_fetchqi;
  ena[607] = HAVE_atomic_nand_fetchhi;
  ena[608] = HAVE_atomic_nand_fetchsi;
  ena[609] = HAVE_atomic_nand_fetchdi;
  ena[610] = HAVE_atomic_nandqi;
  ena[611] = HAVE_atomic_nandhi;
  ena[612] = HAVE_atomic_nandsi;
  ena[613] = HAVE_atomic_nanddi;
  ena[614] = HAVE_atomic_or_fetchqi;
  ena[615] = HAVE_atomic_or_fetchhi;
  ena[616] = HAVE_atomic_or_fetchsi;
  ena[617] = HAVE_atomic_or_fetchdi;
  ena[618] = HAVE_atomic_orqi;
  ena[619] = HAVE_atomic_orhi;
  ena[620] = HAVE_atomic_orsi;
  ena[621] = HAVE_atomic_ordi;
  ena[622] = HAVE_atomic_storeqi;
  ena[623] = HAVE_atomic_storehi;
  ena[624] = HAVE_atomic_storesi;
  ena[625] = HAVE_atomic_storedi;
  ena[626] = HAVE_atomic_sub_fetchqi;
  ena[627] = HAVE_atomic_sub_fetchhi;
  ena[628] = HAVE_atomic_sub_fetchsi;
  ena[629] = HAVE_atomic_sub_fetchdi;
  ena[630] = HAVE_atomic_subqi;
  ena[631] = HAVE_atomic_subhi;
  ena[632] = HAVE_atomic_subsi;
  ena[633] = HAVE_atomic_subdi;
  ena[634] = HAVE_atomic_xor_fetchqi;
  ena[635] = HAVE_atomic_xor_fetchhi;
  ena[636] = HAVE_atomic_xor_fetchsi;
  ena[637] = HAVE_atomic_xor_fetchdi;
  ena[638] = HAVE_atomic_xorqi;
  ena[639] = HAVE_atomic_xorhi;
  ena[640] = HAVE_atomic_xorsi;
  ena[641] = HAVE_atomic_xordi;
  ena[642] = HAVE_get_thread_pointerdi;
}

static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, enum machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '4', "divmod", gen_int_libfunc },
  { '4', "udivmod", gen_int_libfunc },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

